'From Jasmine-rc1 of 7 October 2004 [latest update: #231] on 3 June 2005 at 1:50:49 pm'!
"Change Set:		ASEAnimation
Date:			30 May 2005
Author:			Takashi Yamamiya

(This change set is based on Jasmine #229)
- TLoad3DSMax supports animation.
- TLoad3DSMax parser is now stream base.
- Progress bar is appered when process ASE file.
- TLoad3DSMaxPlugin has mugic number method for test.

(open Teapot before doing followed codes).
TSampledAnimation showExample1.
TLoad3DSMaxTest showMax: TSampledAnimationTest exampleBone readStream
"!

TFrame subclass: #TAnimatedFrame
	instanceVariableNames: 'animation '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Animation'!

!TAnimatedFrame commentStamp: 'tak 11/3/2004 23:24' prior: 0!
Simple animated tframe with TSampledAnimation.

TSampledAnimation showExample1!

TFrame subclass: #TLoad3DSMax
	instanceVariableNames: 'vertices tvertices faces tfaces matIndex stringLoc materialList materialRef textureList scale shadeAngle shadeAngleCos frame textureMode transform inverseTransform aheadChar filePath meshFaceNormals meshFaceVertexNormals linearScale barCount animationBuilder objects '
	classVariableNames: 'DelimSet1 DelimSet2 DelimSet3 NumberSet WhiteSpaceSet '
	poolDictionaries: 'OpenGLConstants '
	category: 'Croquet-Objects'!
TObject subclass: #TLoad3DSMaxAnimationBuilder
	instanceVariableNames: 'firstframe lastframe framespeed ticksperframe animations scaleDictionary '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Animation'!
TObject subclass: #TLoad3DSMaxAnimationNode
	instanceVariableNames: 'frame rotations positions scenario '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Animation'!
TestCase subclass: #TLoad3DSMaxTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants '
	category: 'Croquet-Objects'!

!TLoad3DSMaxTest commentStamp: 'tak 6/3/2005 11:57' prior: 0!
The test can be executed when Teapot is on screen.
TLoad3DSMaxTest buildSuite run!

TObject subclass: #TSampledAnimation
	instanceVariableNames: 'frame now scenario tickspersecond isRepeat ticks track '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Animation'!

!TSampledAnimation commentStamp: 'tak 11/3/2004 22:14' prior: 0!
I represent a sample frame animation.

frame		TFrame -- target frame
now		SmallInteger -- current tick number (You can use any unit as you like)
scenario	Dictionary -- keyframe basic data
tickspersecond	Number -- play speed.
isRepeat		Boolean -- true if the animation is repeating

ticks		Collection -- tick numbers available in the object (cache).
track		Collection -- 'compiled' scenario data for specific frame (cache).

*** Data structure ***

scenario
tick : SmallInteger -> (nodeName : String -> transform: B3DMatrix4x4)

track
tick : SmallInteger -> (frame : TFrame -> transform)

*** Major method ***
tick:nodeName:transform:	Set animation data for the time.
stepAt:						Move objects to defined moment.
now:						Move objects to defined position.
!

TestCase subclass: #TSampledAnimationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Animation'!

!TSampledAnimationTest commentStamp: 'tak 5/30/2005 22:29' prior: 0!
self buildSuite run!


!T3DSParseNode methodsFor: 'printing' stamp: 'tak 5/30/2005 20:13'!
printOn: aStream
	aStream nextPutAll: name! !


!TAnimatedFrame methodsFor: 'testing' stamp: 'tak 10/14/2004 14:48'!
isComponent
	^ true! !

!TAnimatedFrame methodsFor: 'accessing' stamp: 'tak 10/14/2004 14:48'!
animation
	^ animation! !

!TAnimatedFrame methodsFor: 'accessing' stamp: 'tak 10/12/2004 21:01'!
animation: aTKeyFrames 
	animation _ aTKeyFrames.
	self removeAll.
	self addChild: animation frame! !

!TAnimatedFrame methodsFor: 'accessing' stamp: 'tak 10/16/2004 17:09'!
scale: aNumber 
	animation scale: aNumber.
	super scale: aNumber! !

!TAnimatedFrame methodsFor: 'render' stamp: 'tak 11/3/2004 23:22'!
renderFrame: ogl parent: parent root: root 
	animation
		ifNotNil: [animation stepAt: TeaTime now asFloat].
	^ super
		renderFrame: ogl
		parent: parent
		root: root! !

!TAnimatedFrame methodsFor: 'initialize' stamp: 'tak 11/3/2004 23:23'!
initialize
	super initialize.
	self visible: false.! !


!TLoad3DSMax methodsFor: 'convert' stamp: 'tak 6/3/2005 13:34'!
reconstruct

"This method figures out how to reconstruct the mesh based solely upon the face information - material, vertex indices, vertex normals, and texture indices. It creates a group of sub-meshes which are then properly rendered. I realize that this could and should be broken down into many smaller methods, but I don't want to deal with creating throw-away classes that would only be used to help this method. On the other hand, I am very aware that there is a limit on the actual size of a method, so I might have to anyway."

	| faceNormals vertexFaceNormals vi ai ti mi vNorm fvi tvi avi mvi counter found faceGroup mm |

" First, make the face normals and vertex normals. "

	((self recalculateFaceNormals: (faces size)) or: [ meshFaceNormals = nil]) "not a really huge model or didn't get any normals in the ase file"
			 ifTrue:  [ faceNormals _ self calcFaceNormals.]  "compute them"
			 ifFalse: [ Transcript show: 'Faces:', (faces size) asString, ' using file values for face normals'; cr. 
					  faceNormals _ meshFaceNormals.
					  ].
	meshFaceNormals _ nil. "Clear for next use."

	((self recalculateFaceVertexNormals: (faces size)) or: [ meshFaceVertexNormals = nil])  
			"if not a huge model or didn't get any normals in the ase file"
			ifTrue: [vertexFaceNormals _ self calcVertexNormals: faceNormals.]
			ifFalse: [ Transcript show: 'Faces:', (faces size) asString, ' using file values for face vertex normals'; cr.
					vertexFaceNormals _ meshFaceVertexNormals. 
					].
	meshFaceVertexNormals _ nil.  "Clear for next use"

	(tfaces notNil and: [materialRef notNil]) ifTrue: [self calcTextureVertices.].

"Faces now include the following information:
	- 1 Material index - matIndex
	- 3 Vertex indices - faces
	- 3 Vertex normals - vertexFaceNormals
	- 3 texture indices - tfaces
We build a new group of submeshes.
We first look at sub-groups according to materials. Then we compare vertices to build the final face tables.
A vertex is considered equal iff the index, normal, and texture index are identical. Otherwise, it must be aliased."

	vi _ OrderedCollection ofSize: ((vertices size)).
	ai _ OrderedCollection ofSize: ((vertices size)).
	ti _ OrderedCollection ofSize: ((vertices size)).
	mi _ OrderedCollection ofSize: ((vertices size)).
	vNorm _ OrderedCollection ofSize: ((vertices size)).


1 to: faces size do:[ :i |
	found _ false.
	fvi _ 1+ (faces at: i).
	avi _ fvi.
	tfaces ifNotNil:[tvi _ 1 + (tfaces at: i).] 
		ifNil:[tvi _ 1.].
	counter _ 1+(i-1//3).
	mvi _ matIndex at: counter.
	[found] whileFalse:[
		"Anything already in this slot?"
		(vi at: avi) ifNil:[
			vi at: avi put: fvi.
			ti at: avi put: tvi.
			vNorm at: avi put: (vertexFaceNormals at: i).
			mi at: avi put: mvi.
			found _ true.
			].
		"Is what is there already the same as whet we have?"
		found ifFalse:[
			((vi at: avi) = fvi and:[
				(ti at: avi) = tvi and:[
					(mi at: avi) = mvi and:[
						self compare: (vNorm at: avi) 
							and: (vertexFaceNormals at: i) 
							within:0.0001.
							]
						]
					]) ifTrue:[
						faces at: i put: (avi-1).
						found _ true.
						].
			].
		" There is something already there, but it is the wrong thing, we need an alias."
		found ifFalse:[
			(ai at: avi) 
				ifNil:[
					ai add: nil.
					vi add: fvi.
					ti add: tvi.
					vNorm add: (vertexFaceNormals at: i).
					mi add: mvi.
					ai at: avi put: vi size.
					faces at: i put: (vi size)-1.
					found _ true.
					] 
				ifNotNil:[
					avi _ ai at: avi.
					].
				].
			].
		].
"

The following commented out code fragment does the naive job of just adding all of the face information without looking for redundency. It is commented out because IT SHOULD NOT BE USED!! It is here just for reference, because someday, someone will get totally lost in what is going on here and this is a quick and dirty way to simplify the problem. The results are wrong of course, but at least it is a start.
-------
1 to: faces size do:[ :i |						
	vi add: 1+ (faces at:i).
	tfaces ifNotNil:[ ti add: 1 +( tfaces at: i). ] ifNil:[ ti add: 1.].
	vNorm add: (vertexFaceNormals at: i).
	faces at: i put: i-1.].
-------"


"Now clean up the arrays and convert them. The arrays I need to construct here are:
	vertexArray - the actual 3D vertex array including aliases.
	aliasArray - the alias index array - this will be used for vector based animations
	vertexNorms - the vertex normals
	textureArray - the u,v texture coordinate array
which are all the same length, and
	faceGroup - the collection of all faceGroups - check the associated material for alphas.
	"

	vi _ self vertexIndexToArray: vi.
	ai _ self aliasIndexToArray: ai.
	vNorm _ self vertNormToArray: vNorm.
	tfaces ifNotNil:[ti _ self textureIndexToArray: ti.] ifNil:[ ti _ nil.].
	
	faceGroup _ self facesToFaceGroup: faces materials: matIndex.
	mm _ TMesh initializeWithVertices: vi alias: ai norms: vNorm textureUV: ti faceGroups: faceGroup material: (materialRef ifNotNil:[materialList at: 1+materialRef]).    
	mm localTransform: self localTransform.
	mm objectName: self objectName.
	^ mm.! !

!TLoad3DSMax methodsFor: 'parse' stamp: 'tak 10/9/2004 11:49'!
adaptChild: aTFrame parentName: aString 
	"Fixing child's transform is when the imported vertices are 
	pre-transformed, and all of the nodes are in global coordinates and we 
	want to put them back into their untransformed state. This occurs with 
	the 3DS Max ASE files."
	| parent |
	parent _ nil.
	aString
		ifNotNil: [parent _ objects
						detect: [:each | each objectName = aString]
						ifNone: []].
	parent
		ifNil: [frame addChild: aTFrame]
		ifNotNil: [parent addChild: aTFrame.
			aTFrame
				localTransform: (parent globalTransform orthoNormInverse composeWith: aTFrame localTransform)].
	objects addFirst: aTFrame! !

!TLoad3DSMax methodsFor: 'parse' stamp: 'tak 10/6/2004 20:39'!
makeAnimation: tree 
	| animation |
	animation _ TLoad3DSMaxAnimationNode new.
	self
		parseTree: tree
		do: [:fieldName :field | (#(#TControlPosTrack #TControlRotTrack ) includes: fieldName)
				ifTrue: [self makeAnimation: field into: animation]].
	^ animation! !

!TLoad3DSMax methodsFor: 'parse' stamp: 'tak 10/9/2004 17:07'!
makeAnimation: tree into: animation 
	| array |
	self
		parseTree: tree
		do: [:fieldName :field | 
			fieldName = #TControlPosSample
				ifTrue: [array _ self makeNumberArray: field.
					animation
						addPosSample: array first
						x: array second
						y: array third
						z: array fourth
						scale: scale].
			fieldName = #TControlRotSample
				ifTrue: [array _ self makeNumberArray: field.
					animation
						addRotSample: array first
						x: array second
						y: array third
						z: array fourth
						angle: array fifth]]! !

!TLoad3DSMax methodsFor: 'parse' stamp: 'tak 10/9/2004 12:49'!
makeFrame: parseTree bar: bar 
	barCount _ 0.
	frame _ TGroup new.
	animationBuilder _ TLoad3DSMaxAnimationBuilder new.
	self makeGroup: parseTree bar: bar.
	animationBuilder includesAnimation
		ifTrue: [frame _ animationBuilder asAnimatedFrameFor: self frame]! !

!TLoad3DSMax methodsFor: 'parse' stamp: 'tak 6/3/2005 11:56'!
makeGeometry: tree
	"handle the geometry fields"
	| isMesh mesh animation nodeParentName |
	isMesh _ false.
	linearScale _ 1 @ 1 @ 1.
	self parseTree: tree do:[ :fieldName :field |
		fieldName = #THelperobject
			ifTrue: [self makeGeometry: field].
		fieldName = #TNodeName
			ifTrue:[self objectName: (self makeName: field)].
		fieldName = #TNodeTm ifTrue:[ self localTransform: (self makeTransform: field).].
		fieldName = #TMesh ifTrue:[ 
			self makeMesh: field.
			vertices size > 0 ifTrue:[isMesh _ true.].
			].
		fieldName = #TMaterialRef ifTrue:[ materialRef _ self makeNumber: field.].
		fieldName = #TTmAnimation ifTrue:[animation _ self makeAnimation: field].
		fieldName = #TNodeParent
			ifTrue: [nodeParentName _ self makeName: field].
		].

	isMesh ifTrue:[ mesh _ self reconstruct.
					mesh forceGlobalToLocalForASE]
			ifFalse:[ mesh _ TGroup new.
					mesh objectName: (self objectName).
					mesh localTransform: self localTransform.
                       ].
	animationBuilder atFrame: mesh putScale: linearScale.
	animation ifNotNil: [
		animationBuilder addAnimation: animation frame: mesh].
	self adaptChild: mesh parentName: nodeParentName. 
		! !

!TLoad3DSMax methodsFor: 'parse' stamp: 'tak 10/9/2004 12:48'!
makeGroup: tree bar: bar 
	self
		parseTree: tree
		do: [:fieldName :field | 
			barCount _ barCount + 1.
			bar value: barCount.
			fieldName = #TScene
				ifTrue: [self makeScene: field].
			fieldName = #TMaterialList
				ifTrue: [self makeMaterials: field].
			fieldName = #THelperobject
				ifTrue: [self makeGeometry: field].
			fieldName = #TGeomobject
				ifTrue: [self makeGeometry: field].
			fieldName = #TGroup
				ifTrue: [self makeGroup: field bar: bar]]! !

!TLoad3DSMax methodsFor: 'parse' stamp: 'tak 6/3/2005 12:00'!
makeMap: tree

	| txtr fname uOffset vOffset uTiling vTiling angle start end name extend |
" Create a texture based upon information found in the material field."
	extend _ nil.
	uOffset _ 0.0.
	vOffset _ 0.0.
	uTiling _ 1.0.
	vTiling _ 1.0.
	angle _ 0.0.
	self parseTree: tree do:[ :fieldName :field |
		fieldName = #TBitmap ifTrue:[ 
			start _ field findDelimiters:'"' startingAt: 1.
			end _ field findDelimiters: '"' startingAt: start+1.
			fname _ field copyFrom: start+1 to: end-1.
			].
		fieldName = #TUvwUOffset ifTrue:[ uOffset _ self makeNumber: field.].
		fieldName = #TUvwVOffset ifTrue:[ vOffset _ self makeNumber: field.].
		fieldName = #TUvwUTiling ifTrue:[ uTiling _ self makeNumber: field.].
		fieldName = #TUvwVTiling ifTrue:[ vTiling _ self makeNumber: field.].
		fieldName = #TUvwAngle ifTrue:[ angle _ self makeNumber: field.].
		fieldName = #TMapName ifTrue:[ name _ field. 
				start _ name findDelimiters:'$' startingAt: 1.
				start < (name size-1) ifTrue:[
					(name at:(start+1))=$c ifTrue:[extend _ #colorKey.].
					(name at:(start+1))=$a ifTrue:[extend _ #alpha].
					(name at:(start+1))=$f ifTrue:[extend _ #fullBright].
					].
				].
		].
	fname ifNil:[^fname].
	"get file name from full path name - assumes file is a Windows file name"
	fname _ fname reverse.
	end _ fname findDelimiters:'\:'startingAt: 1.
	fname _ (fname copyFrom: 1 to: end-1) reverse.

	fname ifNil:[^fname].
	txtr _ TTexture new initializeWithFileName: (FileDirectory pathFrom: { filePath . fname }) mipmap: true shrinkFit: true extension: extend.
	txtr uvAngle: angle.
	txtr uvOffset: uOffset@vOffset.
	txtr uvScale: uTiling@vTiling.
	txtr objectName: name.
	^ txtr.
	


	! !

!TLoad3DSMax methodsFor: 'parse' stamp: 'tak 6/3/2005 12:01'!
makeMaterial: tree

	| material ambient diffuse specular shininess alpha txtr subMaterialList twoSided |

	alpha _ 1.0.
	shininess _ 50.0.
	material _ TMaterial new.
	twoSided _ false.

	self parseTree: tree do:[ :fieldName :field |
		txtr _ nil.
		fieldName = #TMaterialName ifTrue:[material objectName: field.].
		fieldName = #TMaterialClass ifTrue:["unused"].
		fieldName = #TMaterialAmbient ifTrue:[ambient _ self makeNumberArray: field.].
		fieldName = #TMaterialDiffuse ifTrue:[diffuse _ self makeNumberArray: field].
		fieldName = #TMaterialSpecular ifTrue:[specular _ self makeNumberArray: field].
		fieldName = #TMaterialShine ifTrue:[shininess _ self makeNumber: field].
		fieldName = #TMaterialShinestrength ifTrue:["unused"].
		fieldName = #TMaterialTransparency ifTrue:[
						alpha _ 1.0 - (self makeNumber: field)].
		fieldName = #TMaterialWiresize ifTrue:["unused"].
		fieldName = #TMaterialShading ifTrue:["unused"].
		fieldName = #TMaterialXpFalloff ifTrue:["unused"].
		fieldName = #TMaterialSoften ifTrue:["unused"].
		fieldName = #TMaterialXpType ifTrue:["unused"].
		fieldName = #TMapDiffuse ifTrue:[ txtr _ self makeMap: field.].
		fieldName = #TNumsubmtls ifTrue:[ subMaterialList _ OrderedCollection new.].
		fieldName = #TSubmaterial ifTrue:[ subMaterialList add: (self makeMaterial:field) ].
		fieldName = #TMaterialTwosided ifTrue:[ twoSided _ true. ].
		].
	ambient ifNotNil:[
		ambient add: alpha.
		material ambientColor: ambient asFloatArray.
		].
	diffuse ifNotNil:[
		diffuse add: alpha.
		material diffuseColor: diffuse asFloatArray.
		].
	specular ifNotNil:[
		specular add: 1.0.
		material specularColor: specular asFloatArray.
		].
	material shininess: shininess.
	txtr ifNotNil:[
		material texture: txtr.
		txtr extension = #fullBright 
			ifTrue:[material textureMode: GLReplace.]
			ifFalse:[ material textureMode: textureMode.].
		(txtr extension = #colorKey or:[txtr extension = #alpha])
			ifTrue:[material hasAlpha 
					ifFalse:[ 
						material diffuseColor:(material diffuseColor * 0.99)
						]
					].

		material uvAngle: txtr uvAngle.
		material uvOffset: txtr uvOffset.
		material uvScale: txtr uvScale.
		].

	material subMaterialList: subMaterialList.
	twoSided ifTrue:[ material cullFace: false].
	^ material.
! !

!TLoad3DSMax methodsFor: 'parse' stamp: 'tak 5/30/2005 21:01'!
makeMesh: tree

	| numVertices numFaces numTVertex numTVFaces tarray count matCount tv field2 field3 iterations |

	tvertices _ nil.
	tfaces _ nil.
	meshFaceNormals _ nil.
	meshFaceVertexNormals _ nil.
	
	self parseTree: tree do:[ :fieldName :field |	
		fieldName = #TMeshNumvertex ifTrue:[ 
			numVertices _ self makeNumber: field.
			vertices _ B3DVector3Array new: numVertices. 
			]
		ifFalse:[
		fieldName = #TMeshNumfaces ifTrue:[
			numFaces _ self makeNumber: field.
			faces _ IntegerArray ofSize: (numFaces*3).
			matIndex _ IntegerArray ofSize: numFaces.
			]
		ifFalse:[
		fieldName = #TMeshVertexList ifTrue:[ 
			field ifNotNil:[
				count _ 1.
				field do:[ :node2 |
					field2 _ node2 value.
					tarray _ self makeNumberArray: (field2).
					"NOTE: swap of 3DS y and z coordinates and negation of 3ds y coordinate"
					tarray _ (B3DVector3 x:(tarray at: 2) y: (tarray at: 4) z:(tarray at: 3)negated)*scale.
					vertices at: count put: tarray.
					count _ count+1.
					].
				].
			]
		ifFalse:[
		fieldName = #TMeshFaceList ifTrue:[
			count _ 1.
			matCount _ 1.
			iterations _ 1.
			field do:[ :node2 |
				iterations=1 ifTrue: [field2 _ node2 value].
				iterations=3 ifTrue: [field3 _ node2 value.
					tarray _ self makeNumberArray: (field2).
					faces at: count  put: (tarray at: 2).
					faces at: count+1 put: (tarray at: 3).
					faces at: count+2 put: (tarray at: 4).
					count _ count+3.
					matIndex at: matCount put:(self makeNumber: field3).
					matCount _ matCount + 1.
					iterations _ 0.
					].
				iterations _ iterations + 1.			
				]
			]
		ifFalse:[
		fieldName = #TMeshNumtvertex ifTrue:[
			numTVertex _ self makeNumber:field.
			tvertices _ B3DVector2Array new: numTVertex. 
			]
		ifFalse:[
		fieldName = #TMeshTvertlist ifTrue:[
			count _ 1.
			field do:[ :node2 |
				field2 _ node2 value.
				tarray _ self makeNumberArray: (field2).
				tv _ (B3DVector2 x:(tarray at:2) y:1-(tarray at:3)).
				tvertices at: count put: tv.
				count _ count+1.
				].
			]
		ifFalse:[
		fieldName = #TMeshNumtvfaces ifTrue:[
			numTVFaces _ self makeNumber: field.
			tfaces _ IntegerArray ofSize:(numTVFaces*3). 
			]
		ifFalse:[
		fieldName = #TMeshNormals ifTrue:[
			"if we are recalculating anyway don't bother to get the normals 
				35% of time is spent getting numbers out of the fields" 
			(self recalculateFaceNormals: numFaces) 
				ifFalse: [meshFaceNormals _ self makeFaceNormals: field.].
			(self recalculateFaceVertexNormals: numFaces) 
				ifFalse: [meshFaceVertexNormals _ self makeFaceVertexNormals: field.].
			]
		ifFalse:[

		fieldName = #TMeshTfacelist ifTrue:[
			count _ 1.
			field do:[ :node2 |
				field2 _ node2 value.
				tarray _ self makeNumberArray: (field2).
				tfaces at: count put: (tarray at: 2).
				tfaces at: count+1 put: (tarray at: 3).
				tfaces at: count+2 put: (tarray at: 4).
				count _ count+3.
				].
			].
		]]]]]]]]
		].
! !

!TLoad3DSMax methodsFor: 'parse' stamp: 'tak 10/9/2004 10:37'!
makeName: field 
	| start end |
	start _ field findDelimiters: '"' startingAt: 1.
	end _ field findDelimiters: '"' startingAt: start + 1.
	^ field copyFrom: start + 1 to: end - 1! !

!TLoad3DSMax methodsFor: 'parse' stamp: 'tak 11/4/2004 00:01'!
makeScene: tree 
	self
		parseTree: tree
		do: [:fieldName :field | 
			fieldName = #TSceneFirstframe
				ifTrue: [animationBuilder
						firstframe: (self makeNumber: field)].
			fieldName = #TSceneLastframe
				ifTrue: [animationBuilder
						lastframe: (self makeNumber: field)].
			fieldName = #TSceneFramespeed
				ifTrue: [animationBuilder
						framespeed: (self makeNumber: field)].
			fieldName = #TSceneTicksperframe
				ifTrue: [animationBuilder
						ticksperframe: (self makeNumber: field)]]! !

!TLoad3DSMax methodsFor: 'parse' stamp: 'tak 6/3/2005 12:03'!
makeTransform: tree

	| matrix v mOffset start end m90 |
	matrix _ B3DMatrix4x4 identity.
	self parseTree: tree do:[ :fieldName :field |
		fieldName = #TNodeName ifTrue:[ "I put this here because groups don't give me a node name."
			start _ field findDelimiters: '"' startingAt: 1.
			end _ field findDelimiters: '"' startingAt: start+1.
			self objectName: (field copyFrom: start+1 to: end-1).
			].
		fieldName = #TTmRow0 ifTrue:[ 
			v _ self makeNumberArray: field. 
			matrix a11: (v at: 1).
			matrix a21: (v at: 2).
			matrix a31: (v at: 3).
			].
		fieldName = #TTmRow1 ifTrue:[			
			v _ self makeNumberArray: field. 
			matrix a12: (v at: 1).
			matrix a22: (v at: 2).
			matrix a32: (v at: 3).
			].
		fieldName = #TTmRow2 ifTrue:[
			v _ self makeNumberArray: field. 
			matrix a13: (v at: 1).
			matrix a23: (v at: 2).
			matrix a33: (v at: 3).
			].
		fieldName = #TTmRow3 ifTrue:[ "********TRANSLATION FIELD******"
			v _ self makeNumberArray: field. 
			matrix a14: (v at: 1) * scale.
			matrix a24: (v at: 2) * scale.
			matrix a34: (v at: 3) * scale .
			].
		fieldName = #TTmScale ifTrue:[ "*********SCALE FIELD************"
			v _ self makeNumberArray: field.
			linearScale _ B3DVector3 newFrom: v.
			v at: 1 put:(1.0/v at:1).
			v at: 2 put:(1.0/v at:2).
			v at: 3 put:(1.0/v at:3).
			matrix a11: matrix a11*(v at:1).
			matrix a21: matrix a21*(v at:1).
			matrix a31: matrix a31*(v at:1).

			matrix a12: matrix a12*(v at:2).
			matrix a22: matrix a22*(v at:2).
			matrix a32: matrix a32*(v at:2).

			matrix a13: matrix a13*(v at:3).
			matrix a23: matrix a23*(v at:3).
			matrix a33: matrix a33*(v at:3).
			].
				" I am not sure if I need this next matrix or not."
		fieldName = #TNodeObjectoffset ifTrue:[ 
			mOffset _ self makeTransform: field.
			].
		].

	m90 _ B3DMatrix4x4 identity rotationAroundX:-90.
	matrix _ (m90 composeWith: matrix) composeWith: m90 orthoNormInverse.

"	^ B3DMatrix4x4 identity translation: (matrix translation)."
	^ matrix.! !

!TLoad3DSMax methodsFor: 'parse' stamp: 'tak 5/30/2005 20:53'!
parseTree: parseTree do: aBlock 
	"Enumerate parse tree"
	| fieldName field |
	parseTree
		do: [:node | 
			fieldName _ node name.
			field _ node value.
			aBlock value: fieldName value: field]! !

!TLoad3DSMax methodsFor: 'accessing' stamp: 'tak 6/3/2005 11:45'!
frame
	frame class = TMesh
		ifTrue: [^ frame].
	frame class = TAnimatedFrame
		ifTrue: [^ frame].
	frame frameChildren
		ifNotNil: [frame frameChildren size = 1
				ifTrue: [^ frame frameChildren at: 1]].
	^ frame! !

!TLoad3DSMax methodsFor: 'initialize' stamp: 'tak 7/29/2004 13:53'!
initializeOn: aStream
	^self initializeOn: aStream scale: 1.0 shadeAngle: 90.1 textureMode: GLModulate
! !

!TLoad3DSMax methodsFor: 'initialize' stamp: 'tak 5/30/2005 20:52'!
initializeOn: fileStream scale: scl shadeAngle: angle textureMode: txtrMd
	
	| parseTree |
	Smalltalk garbageCollectMost.
	scale _ scl.
	textureMode _ txtrMd.
	objects _ OrderedCollection new.
	"get full path name of file, and path of directory containing it"

	filePath _ (fileStream isKindOf: StandardFileStream)
		ifTrue: [FileDirectory dirPathFor: fileStream fullName]
		ifFalse: [FileDirectory default pathName].

	parseTree _ self parseOn: fileStream.
	Smalltalk garbageCollectMost.
	self shadeAngle: angle. "Use degrees, but convert to radians"

 	('Building ', fileStream localName)
		displayProgressAt: 0@0
		from: 0
		to: (self flatSize: parseTree)
		during: [:bar | self makeFrame: parseTree bar: bar].
	^self
! !

!TLoad3DSMax methodsFor: 'initialize' stamp: 'tak 6/3/2005 11:46'!
initializeWithFileName: fName scale: scl shadeAngle: angle textureMode: txtrMd 
	| fileName fileStream |
	fileName _ CroquetData findContentFileName: fName.
	fileStream _ (CrLfFileStream readOnlyFileNamed: fileName) ascii.
	self
		initializeOn: fileStream
		scale: scl
		shadeAngle: angle
		textureMode: txtrMd! !

!TLoad3DSMax methodsFor: 'parse tree' stamp: 'tak 11/4/2004 00:03'!
flatSize: tree 
	"count node size of root and group"
	"self basicNew flatSize: #(#a 2 #TGroup (#a 5 #b 7))"
	| count |
	count _ 0.
	self
		parseTree: tree
		do: [:fieldName :field | count _ count
						+ (fieldName = #TGroup
								ifTrue: [self flatSize: field]
								ifFalse: [1])].
	^ count! !

!TLoad3DSMax methodsFor: 'parse tree' stamp: 'tak 6/3/2005 13:29'!
parseFileNamed: fName 

	"MessageTally spyOn: [^ self basicNew parseFileNamed: (FileDirectory  
	pathFrom: {FileDirectory default pathName. 'Content'. 'Mars'.  
	'rover.ASE'})]"
	| fileStream |
	fileStream _ (CrLfFileStream readOnlyFileNamed: fName) ascii.
	[^ self parseOn: fileStream]
		ensure: [fileStream close].
! !

!TLoad3DSMax methodsFor: 'parse tree' stamp: 'tak 7/22/2004 10:14'!
parseOn: fileStream 
	| fName string |
	fName _ fileStream localName.
	[string _ fileStream next: fileStream size]
		ensure: [fileStream close].
	^ self parse: string readStream announcing: 'Parsing ' , fName , ' ...'! !


!TLoad3DSMaxAnimationBuilder methodsFor: 'accessing' stamp: 'tak 10/6/2004 20:23'!
addAnimation: animation frame: frame 
	animation frame: frame.
	animations add: animation! !

!TLoad3DSMaxAnimationBuilder methodsFor: 'accessing' stamp: 'tak 11/3/2004 23:29'!
asAnimatedFrameFor: frame 
	| keyframes |
	keyframes _ TSampledAnimation new frame: frame.
	keyframes isRepeat: true.
	keyframes tickspersecond: framespeed * ticksperframe.
	animations
		do: [:animation | 
			animation buildMatrixWithScaleDictionary: scaleDictionary.
			keyframes addBuilder: animation].
	^ TAnimatedFrame new animation: keyframes! !

!TLoad3DSMaxAnimationBuilder methodsFor: 'accessing' stamp: 'tak 10/9/2004 18:29'!
atFrame: aTFrame putScale: scale
	scaleDictionary at: aTFrame put: scale.
	^ scale! !

!TLoad3DSMaxAnimationBuilder methodsFor: 'accessing' stamp: 'tak 10/6/2004 19:39'!
firstframe: aNumber
	firstframe _ aNumber! !

!TLoad3DSMaxAnimationBuilder methodsFor: 'accessing' stamp: 'tak 10/6/2004 19:39'!
framespeed: aNumber
	framespeed _ aNumber! !

!TLoad3DSMaxAnimationBuilder methodsFor: 'accessing' stamp: 'tak 10/6/2004 20:25'!
includesAnimation
	^ animations size > 0! !

!TLoad3DSMaxAnimationBuilder methodsFor: 'accessing' stamp: 'tak 10/6/2004 19:39'!
lastframe: aNumber
	lastframe _ aNumber! !

!TLoad3DSMaxAnimationBuilder methodsFor: 'accessing' stamp: 'tak 10/6/2004 19:39'!
ticksperframe: aNumber
	ticksperframe _ aNumber! !

!TLoad3DSMaxAnimationBuilder methodsFor: 'initialize' stamp: 'tak 10/9/2004 18:28'!
initialize
	animations _ OrderedCollection new.
	scaleDictionary _ IdentityDictionary new.! !


!TLoad3DSMaxAnimationNode methodsFor: 'building' stamp: 'tak 11/3/2004 23:28'!
buildMatrixWithScaleDictionary: scaleDictionary 
	"Build matrix data from rotations, positions and frame positions"
	| positionDictionary rotationDictionary keys matrix lastPosition lastRotation scale |
	scenario _ IdentityDictionary new.
	lastPosition _ frame translation.
	scale _ frame parent
				ifNotNil: [scaleDictionary
						at: frame parent
						ifAbsent: []].
	scale
		ifNil: [scale _ 1 @ 1 @ 1].
	lastRotation _ rotations size = 0
				ifTrue: [frame localTransform asQuaternion]
				ifFalse: [B3DRotation identity].
	positionDictionary _ self orderedCollectionToDictionary: positions.
	rotationDictionary _ self orderedCollectionToDictionary: rotations.
	keys _ positionDictionary keys union: rotationDictionary keys.
	keys add: 0.
	keys asSortedCollection
		do: [:key | 
			(rotationDictionary includesKey: key)
				ifTrue: [lastRotation _ lastRotation
								* (rotationDictionary at: key)].
			matrix _ lastRotation asMatrix4x4.
			matrix
				translation: ((positionDictionary includesKey: key)
						ifTrue: [lastPosition _ (positionDictionary at: key)
										* scale]
						ifFalse: [lastPosition]).
			scenario at: key put: matrix]! !

!TLoad3DSMaxAnimationNode methodsFor: 'building' stamp: 'tak 10/14/2004 14:53'!
ticks
	^ scenario keys! !

!TLoad3DSMaxAnimationNode methodsFor: 'building' stamp: 'tak 10/14/2004 14:52'!
transformAt: ticks 
	^ scenario at: ticks ! !

!TLoad3DSMaxAnimationNode methodsFor: 'initialize' stamp: 'tak 10/6/2004 19:31'!
initialize
	rotations _ OrderedCollection new.
	positions _ OrderedCollection new.
! !

!TLoad3DSMaxAnimationNode methodsFor: 'accessing' stamp: 'tak 10/6/2004 19:23'!
addPosSample: key x: x y: y z: z scale: scale 
	| position |
	position _ x @ z @ y negated * scale.
	positions add: {key. position}! !

!TLoad3DSMaxAnimationNode methodsFor: 'accessing' stamp: 'tak 10/6/2004 19:23'!
addRotSample: key x: x y: y z: z angle: angle 
	| rot |
	rot _ B3DRotation radiansAngle: angle negated axis: x @ z @ y negated.
	rotations add: {key. rot}! !

!TLoad3DSMaxAnimationNode methodsFor: 'accessing' stamp: 'tak 10/14/2004 14:53'!
frame: aTFrame 
	frame _ aTFrame! !

!TLoad3DSMaxAnimationNode methodsFor: 'accessing' stamp: 'tak 10/14/2004 14:52'!
nodeName
	^ frame
		ifNil: ['']
		ifNotNil: [frame objectName]! !

!TLoad3DSMaxAnimationNode methodsFor: 'accessing' stamp: 'tak 10/14/2004 14:52'!
orderedCollectionToDictionary: aCollection 
	| dict |
	dict _ IdentityDictionary new.
	aCollection
		do: [:each | dict at: each first put: each second].
	^ dict! !


!TLoad3DSMaxPlugin methodsFor: 'system primitives' stamp: 'tak 7/22/2004 22:34'!
primMagicNumber
	self primitive: 'primMagicNumber' parameters: #().
	^ 7 asOop: SmallInteger! !


!TLoad3DSMaxTest methodsFor: 'Testing' stamp: 'tak 7/22/2004 22:36'!
primMagicNumber
	<primitive: 'primMagicNumber' module: 'TLoad3DSMaxPlugin'>
	^ 0
! !

!TLoad3DSMaxTest methodsFor: 'Testing' stamp: 'tak 10/16/2004 15:55'!
testGroup
	"self debug: #testGroup"
	| max frame group1 dummy2 pyramid2 |
	max _ TLoad3DSMax basicNew initializeOn: self class exampleGroup readStream.
	frame _ max frame.
	self assert: frame frameChildren size = 1.
	self assert: (group1 _ frame frameChildren first) objectName = 'Group01'.
	self assert: group1 frameChildren size = 1.
	self assert: (dummy2 _ group1 frameChildren first) objectName = 'Dummy02'.
	self assert: dummy2 frameChildren size = 1.
	self assert: (pyramid2 _ dummy2 frameChildren first) objectName = 'Pyramid02'.
	self assert: pyramid2 frameChildren isNil.
! !

!TLoad3DSMaxTest methodsFor: 'Testing' stamp: 'tak 10/9/2004 12:36'!
testPhone
	"self debug: #testPhone"
	| tframe2 path max |
	path _ {FileDirectory default pathName. 'Content'. 'Widgets'. 'phone.ASE'}.
	max _ (TLoad3DSMax new
				initializeWithFileName: (FileDirectory pathFrom: path)
				scale: 1.0).
	tframe2 _ max frame.
	self
		assert: ((tframe2
				find: [:frm | frm objectName = 'receiver']) second isKindOf: TFrame)! !

!TLoad3DSMaxTest methodsFor: 'Testing' stamp: 'tak 7/22/2004 22:37'!
testPrimitive
	self assert: TLoad3DSMaxTest new primMagicNumber = 7! !

!TLoad3DSMaxTest methodsFor: 'Testing' stamp: 'tak 10/9/2004 11:31'!
testSamename
	"self debug: #testSamename"
	| max frame pyramid1 pyramid2 |
	max _ TLoad3DSMax new initializeOn: self class exampleSamename readStream.
	frame _ max frame.
	pyramid1 _ frame frameChildren first frameChildren first.
	pyramid2 _ frame frameChildren second frameChildren first.
	self assert: pyramid1 objectName = 'Pyramid01'.
	self assert: pyramid2 objectName = 'Pyramid02'.
	self assert: pyramid1 translation = (0 @ 50 @ 0).
	self assert: pyramid2 translation = (0 @ 50 @ 0).
! !

!TLoad3DSMaxTest methodsFor: 'parser test' stamp: 'tak 6/23/2004 10:57'!
testNextToken
	| strm tload ans |
	strm _ '*3DSMAX_ASCIIEXPORT	200' readStream.
	tload _ TLoad3DSMax basicNew reset.
	ans _ tload nextOn: strm.
	self assert: ans first = #T3dsmaxAsciiexport.
	self assert: ans second = '200'.
	self assert: (ans _ tload nextOn: strm) first = #EOF.
! !

!TLoad3DSMaxTest methodsFor: 'parser test' stamp: 'tak 5/30/2005 19:57'!
testParse
	| source tree |
	source _ '*3DSMAX_ASCIIEXPORT	200'.
	tree _ TLoad3DSMax basicNew parseOn: source readStream.
	self assert: tree first name = #T3dsmaxAsciiexport.
	self assert: tree first value = '200'.! !

!TLoad3DSMaxTest methodsFor: 'parser test' stamp: 'tak 5/30/2005 20:16'!
testParseNesting
	| source tree |
	source _ '
*FIRST 1
*SECOND  2 {
	*THIRD 3 {
		*FOURTH 4
	}
}
*FIFTH 5
'.
	tree _ TLoad3DSMax basicNew parseOn: source readStream.
	self assert: tree first name = #TFirst.
	self assert: tree first nextLink value first value first name = #TFourth.
! !

!TLoad3DSMaxTest methodsFor: 'parser test' stamp: 'tak 5/30/2005 20:17'!
testParseNesting2
	| source tree |
	source _ '
*FIRST 1
*SECOND  2 {
	*THIRD 3 {
	}
}
*FIFTH 5
'.
	tree _ TLoad3DSMax basicNew parseOn: source readStream.
	self assert: tree first name = #TFirst.
	self assert: tree last value = '5'.
! !


!TLoad3DSMaxTest class methodsFor: 'benchmark' stamp: 'tak 10/18/2004 12:23'!
showMax: fileNameOrStream 
	self
		showMax: fileNameOrStream
		offset: 0 @ 0 @ 0
		scale: 0.01
		number: 1! !

!TLoad3DSMaxTest class methodsFor: 'benchmark' stamp: 'tak 10/18/2004 12:21'!
showMax: fileNameOrStream offset: offset scale: scale number: aNumber 
	"Show 3ds max data in active croquet window.  
	The method can be executed when a TeapotMorph is on screen."
	| ff max frame aMax |
	ff _ fileNameOrStream isStream
				ifTrue: [fileNameOrStream]
				ifFalse: [FileStream readOnlyFileNamed: fileNameOrStream].
	[max _ TLoad3DSMax new
				initializeOn: ff
				scale: scale
				shadeAngle: 90.1
				textureMode: GLReplace]
		ensure: [ff close].
	1
		to: aNumber * 2
		by: 2
		do: [:i | 
			aMax _ max veryDeepCopy.
			"aMax inspect."
			frame _ aMax frame.
			CroquetGlobals theTeapotMorph activeCamera addFrameInFront: aMax frame.
			frame translation: frame translation + (i @ 0 @ 0) + offset]! !

!TLoad3DSMaxTest class methodsFor: 'examples' stamp: 'tak 10/18/2004 12:23'!
exampleGroup
	"TLoad3DSMaxTest showMax: self exampleGroup readStream"

^ '*3DSMAX_ASCIIEXPORT	200
*COMMENT "AsciiExport Version  2.00 - Fri Oct 08 19:22:15 2004"
*SCENE {
	*SCENE_FILENAME "dummyRotation1.max"
	*SCENE_FIRSTFRAME 0
	*SCENE_LASTFRAME 60
	*SCENE_FRAMESPEED 30
	*SCENE_TICKSPERFRAME 160
	*SCENE_BACKGROUND_STATIC 0.0000	0.0000	0.0000
	*SCENE_AMBIENT_STATIC 0.0000	0.0000	0.0000
}
*MATERIAL_LIST {
	*MATERIAL_COUNT 0
}
*GROUP "Group01" {
	*HELPEROBJECT {
		*NODE_NAME "Group01"
		*HELPER_CLASS "Dummy"
		*NODE_TM {
			*NODE_NAME "Group01"
			*INHERIT_POS 0 0 0
			*INHERIT_ROT 0 0 0
			*INHERIT_SCL 0 0 0
			*TM_ROW0 1.0000	0.0000	0.0000
			*TM_ROW1 0.0000	1.0000	0.0000
			*TM_ROW2 0.0000	0.0000	1.0000
			*TM_ROW3 0.0000	0.0000	0.0000
			*TM_POS 0.0000	0.0000	0.0000
			*TM_ROTAXIS 0.0000	0.0000	0.0000
			*TM_ROTANGLE 0.0000
			*TM_SCALE 1.0000	1.0000	1.0000
			*TM_SCALEAXIS 0.0000	0.0000	0.0000
			*TM_SCALEAXISANG 0.0000
		}
		*BOUNDINGBOX_MIN -24.3478	-20.0000	-14.3478
		*BOUNDINGBOX_MAX 24.3478	20.0000	14.3478
	}
	*HELPEROBJECT {
		*NODE_NAME "Dummy02"
		*NODE_PARENT "Group01"
		*HELPER_CLASS "Dummy"
		*NODE_TM {
			*NODE_NAME "Dummy02"
			*INHERIT_POS 0 0 0
			*INHERIT_ROT 0 0 0
			*INHERIT_SCL 0 0 0
			*TM_ROW0 1.0000	0.0000	0.0000
			*TM_ROW1 0.0000	1.0000	0.0000
			*TM_ROW2 0.0000	0.0000	1.0000
			*TM_ROW3 -15.6522	-0.0000	-5.6522
			*TM_POS -15.6522	-0.0000	-5.6522
			*TM_ROTAXIS 0.0000	0.0000	0.0000
			*TM_ROTANGLE 0.0000
			*TM_SCALE 1.0000	1.0000	1.0000
			*TM_SCALEAXIS 0.0000	0.0000	0.0000
			*TM_SCALEAXISANG 0.0000
		}
		*BOUNDINGBOX_MIN -24.3478	-8.6957	-14.3478
		*BOUNDINGBOX_MAX -6.9565	8.6957	3.0435
		*TM_ANIMATION {
			*NODE_NAME "Dummy02"
			*CONTROL_ROT_TRACK {
				*CONTROL_ROT_SAMPLE 800	0.0000	1.0000	0.0000	0.1164
				*CONTROL_ROT_SAMPLE 1600	0.0000	1.0000	0.0000	0.2909
				*CONTROL_ROT_SAMPLE 2400	0.0000	1.0000	0.0000	0.3782
				*CONTROL_ROT_SAMPLE 3200	0.0000	1.0000	0.0000	0.3782
				*CONTROL_ROT_SAMPLE 4000	0.0000	1.0000	0.0000	0.2909
				*CONTROL_ROT_SAMPLE 4800	0.0000	1.0000	0.0000	0.1164
			}
		}
	}
	*GEOMOBJECT {
		*NODE_NAME "Pyramid02"
		*NODE_PARENT "Dummy02"
		*NODE_TM {
			*NODE_NAME "Pyramid02"
			*INHERIT_POS 0 0 0
			*INHERIT_ROT 0 0 0
			*INHERIT_SCL 0 0 0
			*TM_ROW0 1.0000	0.0000	0.0000
			*TM_ROW1 0.0000	1.0000	0.0000
			*TM_ROW2 0.0000	0.0000	1.0000
			*TM_ROW3 4.3478	-0.0000	-5.6522
			*TM_POS 4.3478	-0.0000	-5.6522
			*TM_ROTAXIS 0.0000	0.0000	0.0000
			*TM_ROTANGLE 0.0000
			*TM_SCALE 1.0000	1.0000	1.0000
			*TM_SCALEAXIS 0.0000	0.0000	0.0000
			*TM_SCALEAXISANG 0.0000
		}
		*MESH {
			*TIMEVALUE 0
			*MESH_NUMVERTEX 6
			*MESH_NUMFACES 8
			*MESH_VERTEX_LIST {
				*MESH_VERTEX    0	4.3478	-0.0000	14.3478
				*MESH_VERTEX    1	-15.6522	-20.0000	-5.6522
				*MESH_VERTEX    2	24.3478	-20.0000	-5.6522
				*MESH_VERTEX    3	24.3478	20.0000	-5.6522
				*MESH_VERTEX    4	-15.6522	20.0000	-5.6522
				*MESH_VERTEX    5	4.3478	-0.0000	-5.6522
			}
			*MESH_FACE_LIST {
				*MESH_FACE    0:    A:    0 B:    1 C:    2 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
				*MESH_FACE    1:    A:    0 B:    2 C:    3 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 2 	*MESH_MTLID 0
				*MESH_FACE    2:    A:    0 B:    3 C:    4 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 5 	*MESH_MTLID 0
				*MESH_FACE    3:    A:    0 B:    4 C:    1 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 6 	*MESH_MTLID 0
				*MESH_FACE    4:    A:    1 B:    5 C:    2 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
				*MESH_FACE    5:    A:    2 B:    5 C:    3 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
				*MESH_FACE    6:    A:    3 B:    5 C:    4 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
				*MESH_FACE    7:    A:    4 B:    5 C:    1 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
			}
			*MESH_NUMTVERTEX 10
			*MESH_TVERTLIST {
				*MESH_TVERT 0	0.5000	1.0000	0.0000
				*MESH_TVERT 1	0.0000	0.0000	0.0000
				*MESH_TVERT 2	1.0000	0.0000	0.0000
				*MESH_TVERT 3	0.0000	0.0000	0.0000
				*MESH_TVERT 4	1.0000	0.0000	0.0000
				*MESH_TVERT 5	0.0000	1.0000	0.0000
				*MESH_TVERT 6	1.0000	1.0000	0.0000
				*MESH_TVERT 7	1.0000	0.0000	0.0000
				*MESH_TVERT 8	0.0000	0.0000	0.0000
				*MESH_TVERT 9	0.5000	0.5000	0.0000
			}
			*MESH_NUMTVFACES 8
			*MESH_TFACELIST {
				*MESH_TFACE 0	0	1	2
				*MESH_TFACE 1	0	3	4
				*MESH_TFACE 2	0	1	2
				*MESH_TFACE 3	0	3	4
				*MESH_TFACE 4	5	9	6
				*MESH_TFACE 5	6	9	7
				*MESH_TFACE 6	7	9	8
				*MESH_TFACE 7	8	9	5
			}
			*MESH_NUMCVERTEX 0
			*MESH_NORMALS {
				*MESH_FACENORMAL 0	0.0000	-0.7071	0.7071
					*MESH_VERTEXNORMAL 0	0.0000	-0.7071	0.7071
					*MESH_VERTEXNORMAL 1	0.0000	-0.7071	0.7071
					*MESH_VERTEXNORMAL 2	0.0000	-0.7071	0.7071
				*MESH_FACENORMAL 1	0.7071	0.0000	0.7071
					*MESH_VERTEXNORMAL 0	0.7071	0.0000	0.7071
					*MESH_VERTEXNORMAL 2	0.7071	0.0000	0.7071
					*MESH_VERTEXNORMAL 3	0.7071	0.0000	0.7071
				*MESH_FACENORMAL 2	0.0000	0.7071	0.7071
					*MESH_VERTEXNORMAL 0	0.0000	0.7071	0.7071
					*MESH_VERTEXNORMAL 3	0.0000	0.7071	0.7071
					*MESH_VERTEXNORMAL 4	0.0000	0.7071	0.7071
				*MESH_FACENORMAL 3	-0.7071	0.0000	0.7071
					*MESH_VERTEXNORMAL 0	-0.7071	0.0000	0.7071
					*MESH_VERTEXNORMAL 4	-0.7071	0.0000	0.7071
					*MESH_VERTEXNORMAL 1	-0.7071	0.0000	0.7071
				*MESH_FACENORMAL 4	0.0000	0.0000	-1.0000
					*MESH_VERTEXNORMAL 1	0.0000	0.0000	-1.0000
					*MESH_VERTEXNORMAL 5	0.0000	0.0000	-1.0000
					*MESH_VERTEXNORMAL 2	0.0000	0.0000	-1.0000
				*MESH_FACENORMAL 5	0.0000	0.0000	-1.0000
					*MESH_VERTEXNORMAL 2	0.0000	0.0000	-1.0000
					*MESH_VERTEXNORMAL 5	0.0000	0.0000	-1.0000
					*MESH_VERTEXNORMAL 3	0.0000	0.0000	-1.0000
				*MESH_FACENORMAL 6	0.0000	0.0000	-1.0000
					*MESH_VERTEXNORMAL 3	0.0000	0.0000	-1.0000
					*MESH_VERTEXNORMAL 5	0.0000	0.0000	-1.0000
					*MESH_VERTEXNORMAL 4	0.0000	0.0000	-1.0000
				*MESH_FACENORMAL 7	0.0000	0.0000	-1.0000
					*MESH_VERTEXNORMAL 4	0.0000	0.0000	-1.0000
					*MESH_VERTEXNORMAL 5	0.0000	0.0000	-1.0000
					*MESH_VERTEXNORMAL 1	0.0000	0.0000	-1.0000
			}
		}
		*PROP_MOTIONBLUR 0
		*PROP_CASTSHADOW 1
		*PROP_RECVSHADOW 1
		*WIREFRAME_COLOR 0.3451	0.5608	0.8824
	}
}
'! !

!TLoad3DSMaxTest class methodsFor: 'examples' stamp: 'tak 10/18/2004 12:25'!
exampleSamename
	"TLoad3DSMaxTest showMax: self exampleSamename readStream"
^ '*3DSMAX_ASCIIEXPORT	200
*COMMENT "AsciiExport Version  2.00 - Sat Oct 09 10:11:06 2004"
*SCENE {
	*SCENE_FILENAME ""
	*SCENE_FIRSTFRAME 0
	*SCENE_LASTFRAME 100
	*SCENE_FRAMESPEED 30
	*SCENE_TICKSPERFRAME 160
	*SCENE_BACKGROUND_STATIC 0.0000	0.0000	0.0000
	*SCENE_AMBIENT_STATIC 0.0000	0.0000	0.0000
}
*MATERIAL_LIST {
	*MATERIAL_COUNT 0
}
*GEOMOBJECT {
	*NODE_NAME "Box"
	*NODE_TM {
		*NODE_NAME "Box"
		*INHERIT_POS 0 0 0
		*INHERIT_ROT 0 0 0
		*INHERIT_SCL 0 0 0
		*TM_ROW0 1.0000	0.0000	0.0000
		*TM_ROW1 0.0000	-0.0000	1.0000
		*TM_ROW2 0.0000	-1.0000	-0.0000
		*TM_ROW3 -20.0000	0.0000	0.0000
		*TM_POS -20.0000	0.0000	0.0000
		*TM_ROTAXIS -1.0000	0.0000	0.0000
		*TM_ROTANGLE 1.5708
		*TM_SCALE 1.0000	1.0000	1.0000
		*TM_SCALEAXIS 0.0000	0.0000	0.0000
		*TM_SCALEAXISANG 0.0000
	}
	*MESH {
		*TIMEVALUE 0
		*MESH_NUMVERTEX 8
		*MESH_NUMFACES 12
		*MESH_VERTEX_LIST {
			*MESH_VERTEX    0	-25.0000	0.0000	-5.0000
			*MESH_VERTEX    1	-15.0000	0.0000	-5.0000
			*MESH_VERTEX    2	-25.0000	-0.0000	5.0000
			*MESH_VERTEX    3	-15.0000	-0.0000	5.0000
			*MESH_VERTEX    4	-25.0000	-50.0000	-5.0000
			*MESH_VERTEX    5	-15.0000	-50.0000	-5.0000
			*MESH_VERTEX    6	-25.0000	-50.0000	5.0000
			*MESH_VERTEX    7	-15.0000	-50.0000	5.0000
		}
		*MESH_FACE_LIST {
			*MESH_FACE    0:    A:    0 B:    2 C:    3 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    1:    A:    3 B:    1 C:    0 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    2:    A:    4 B:    5 C:    7 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    3:    A:    7 B:    6 C:    4 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    4:    A:    0 B:    1 C:    5 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 4 	*MESH_MTLID 4
			*MESH_FACE    5:    A:    5 B:    4 C:    0 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 4 	*MESH_MTLID 4
			*MESH_FACE    6:    A:    1 B:    3 C:    7 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 5 	*MESH_MTLID 3
			*MESH_FACE    7:    A:    7 B:    5 C:    1 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 5 	*MESH_MTLID 3
			*MESH_FACE    8:    A:    3 B:    2 C:    6 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE    9:    A:    6 B:    7 C:    3 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE   10:    A:    2 B:    0 C:    4 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 7 	*MESH_MTLID 2
			*MESH_FACE   11:    A:    4 B:    6 C:    2 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 7 	*MESH_MTLID 2
		}
		*MESH_NUMTVERTEX 12
		*MESH_TVERTLIST {
			*MESH_TVERT 0	0.0000	0.0000	0.0000
			*MESH_TVERT 1	1.0000	0.0000	0.0000
			*MESH_TVERT 2	0.0000	1.0000	0.0000
			*MESH_TVERT 3	1.0000	1.0000	0.0000
			*MESH_TVERT 4	0.0000	0.0000	0.0000
			*MESH_TVERT 5	1.0000	0.0000	0.0000
			*MESH_TVERT 6	0.0000	1.0000	0.0000
			*MESH_TVERT 7	1.0000	1.0000	0.0000
			*MESH_TVERT 8	0.0000	0.0000	0.0000
			*MESH_TVERT 9	1.0000	0.0000	0.0000
			*MESH_TVERT 10	0.0000	1.0000	0.0000
			*MESH_TVERT 11	1.0000	1.0000	0.0000
		}
		*MESH_NUMTVFACES 12
		*MESH_TFACELIST {
			*MESH_TFACE 0	9	11	10
			*MESH_TFACE 1	10	8	9
			*MESH_TFACE 2	8	9	11
			*MESH_TFACE 3	11	10	8
			*MESH_TFACE 4	4	5	7
			*MESH_TFACE 5	7	6	4
			*MESH_TFACE 6	0	1	3
			*MESH_TFACE 7	3	2	0
			*MESH_TFACE 8	4	5	7
			*MESH_TFACE 9	7	6	4
			*MESH_TFACE 10	0	1	3
			*MESH_TFACE 11	3	2	0
		}
		*MESH_NUMCVERTEX 0
		*MESH_NORMALS {
			*MESH_FACENORMAL 0	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 0	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 2	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 3	0.0000	0.0000	-1.0000
			*MESH_FACENORMAL 1	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 3	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 1	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 0	0.0000	0.0000	-1.0000
			*MESH_FACENORMAL 2	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 4	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 5	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 7	0.0000	0.0000	1.0000
			*MESH_FACENORMAL 3	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 7	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 6	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 4	0.0000	0.0000	1.0000
			*MESH_FACENORMAL 4	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 0	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 1	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 5	0.0000	-1.0000	0.0000
			*MESH_FACENORMAL 5	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 5	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 4	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 0	0.0000	-1.0000	0.0000
			*MESH_FACENORMAL 6	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 1	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 3	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 7	1.0000	0.0000	0.0000
			*MESH_FACENORMAL 7	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 7	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 5	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 1	1.0000	0.0000	0.0000
			*MESH_FACENORMAL 8	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 3	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 2	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 6	0.0000	1.0000	0.0000
			*MESH_FACENORMAL 9	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 6	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 7	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 3	0.0000	1.0000	0.0000
			*MESH_FACENORMAL 10	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 2	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 0	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 4	-1.0000	0.0000	0.0000
			*MESH_FACENORMAL 11	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 4	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 6	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 2	-1.0000	0.0000	0.0000
		}
	}
	*PROP_MOTIONBLUR 0
	*PROP_CASTSHADOW 1
	*PROP_RECVSHADOW 1
	*WIREFRAME_COLOR 0.0314	0.0314	0.5333
}
*GEOMOBJECT {
	*NODE_NAME "Pyramid01"
	*NODE_PARENT "Box"
	*NODE_TM {
		*NODE_NAME "Pyramid01"
		*INHERIT_POS 0 0 0
		*INHERIT_ROT 0 0 0
		*INHERIT_SCL 0 0 0
		*TM_ROW0 1.0000	0.0000	0.0000
		*TM_ROW1 0.0000	-0.0000	1.0000
		*TM_ROW2 0.0000	-1.0000	-0.0000
		*TM_ROW3 -20.0000	-50.0000	-0.0000
		*TM_POS -20.0000	-50.0000	-0.0000
		*TM_ROTAXIS -1.0000	0.0000	0.0000
		*TM_ROTANGLE 1.5708
		*TM_SCALE 1.0000	1.0000	1.0000
		*TM_SCALEAXIS 0.0000	0.0000	0.0000
		*TM_SCALEAXISANG 0.0000
	}
	*MESH {
		*TIMEVALUE 0
		*MESH_NUMVERTEX 6
		*MESH_NUMFACES 8
		*MESH_VERTEX_LIST {
			*MESH_VERTEX    0	-20.0000	-60.0000	-0.0000
			*MESH_VERTEX    1	-35.0000	-50.0000	-15.0000
			*MESH_VERTEX    2	-5.0000	-50.0000	-15.0000
			*MESH_VERTEX    3	-5.0000	-50.0000	15.0000
			*MESH_VERTEX    4	-35.0000	-50.0000	15.0000
			*MESH_VERTEX    5	-20.0000	-50.0000	-0.0000
		}
		*MESH_FACE_LIST {
			*MESH_FACE    0:    A:    0 B:    1 C:    2 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    1:    A:    0 B:    2 C:    3 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 2 	*MESH_MTLID 0
			*MESH_FACE    2:    A:    0 B:    3 C:    4 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 5 	*MESH_MTLID 0
			*MESH_FACE    3:    A:    0 B:    4 C:    1 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 6 	*MESH_MTLID 0
			*MESH_FACE    4:    A:    1 B:    5 C:    2 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
			*MESH_FACE    5:    A:    2 B:    5 C:    3 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
			*MESH_FACE    6:    A:    3 B:    5 C:    4 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
			*MESH_FACE    7:    A:    4 B:    5 C:    1 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
		}
		*MESH_NUMTVERTEX 10
		*MESH_TVERTLIST {
			*MESH_TVERT 0	0.5000	1.0000	0.0000
			*MESH_TVERT 1	0.0000	0.0000	0.0000
			*MESH_TVERT 2	1.0000	0.0000	0.0000
			*MESH_TVERT 3	0.0000	0.0000	0.0000
			*MESH_TVERT 4	1.0000	0.0000	0.0000
			*MESH_TVERT 5	0.0000	1.0000	0.0000
			*MESH_TVERT 6	1.0000	1.0000	0.0000
			*MESH_TVERT 7	1.0000	0.0000	0.0000
			*MESH_TVERT 8	0.0000	0.0000	0.0000
			*MESH_TVERT 9	0.5000	0.5000	0.0000
		}
		*MESH_NUMTVFACES 8
		*MESH_TFACELIST {
			*MESH_TFACE 0	0	1	2
			*MESH_TFACE 1	0	3	4
			*MESH_TFACE 2	0	1	2
			*MESH_TFACE 3	0	3	4
			*MESH_TFACE 4	5	9	6
			*MESH_TFACE 5	6	9	7
			*MESH_TFACE 6	7	9	8
			*MESH_TFACE 7	8	9	5
		}
		*MESH_NUMCVERTEX 0
		*MESH_NORMALS {
			*MESH_FACENORMAL 0	0.0000	-0.5547	0.8321
				*MESH_VERTEXNORMAL 0	0.0000	-0.5547	0.8321
				*MESH_VERTEXNORMAL 1	0.0000	-0.5547	0.8321
				*MESH_VERTEXNORMAL 2	0.0000	-0.5547	0.8321
			*MESH_FACENORMAL 1	0.5547	0.0000	0.8321
				*MESH_VERTEXNORMAL 0	0.5547	0.0000	0.8321
				*MESH_VERTEXNORMAL 2	0.5547	0.0000	0.8321
				*MESH_VERTEXNORMAL 3	0.5547	0.0000	0.8321
			*MESH_FACENORMAL 2	0.0000	0.5547	0.8321
				*MESH_VERTEXNORMAL 0	0.0000	0.5547	0.8321
				*MESH_VERTEXNORMAL 3	0.0000	0.5547	0.8321
				*MESH_VERTEXNORMAL 4	0.0000	0.5547	0.8321
			*MESH_FACENORMAL 3	-0.5547	0.0000	0.8321
				*MESH_VERTEXNORMAL 0	-0.5547	0.0000	0.8321
				*MESH_VERTEXNORMAL 4	-0.5547	0.0000	0.8321
				*MESH_VERTEXNORMAL 1	-0.5547	0.0000	0.8321
			*MESH_FACENORMAL 4	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 1	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 5	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 2	0.0000	0.0000	-1.0000
			*MESH_FACENORMAL 5	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 2	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 5	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 3	0.0000	0.0000	-1.0000
			*MESH_FACENORMAL 6	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 3	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 5	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 4	0.0000	0.0000	-1.0000
			*MESH_FACENORMAL 7	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 4	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 5	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 1	0.0000	0.0000	-1.0000
		}
	}
	*PROP_MOTIONBLUR 0
	*PROP_CASTSHADOW 1
	*PROP_RECVSHADOW 1
	*WIREFRAME_COLOR 0.8392	0.8980	0.6510
}
*GEOMOBJECT {
	*NODE_NAME "Box"
	*NODE_TM {
		*NODE_NAME "Box"
		*INHERIT_POS 0 0 0
		*INHERIT_ROT 0 0 0
		*INHERIT_SCL 0 0 0
		*TM_ROW0 1.0000	0.0000	0.0000
		*TM_ROW1 0.0000	1.0000	0.0000
		*TM_ROW2 0.0000	0.0000	1.0000
		*TM_ROW3 20.0000	0.0000	0.0000
		*TM_POS 20.0000	0.0000	0.0000
		*TM_ROTAXIS 0.0000	0.0000	0.0000
		*TM_ROTANGLE 0.0000
		*TM_SCALE 1.0000	1.0000	1.0000
		*TM_SCALEAXIS 0.0000	0.0000	0.0000
		*TM_SCALEAXISANG 0.0000
	}
	*MESH {
		*TIMEVALUE 0
		*MESH_NUMVERTEX 8
		*MESH_NUMFACES 12
		*MESH_VERTEX_LIST {
			*MESH_VERTEX    0	15.0000	-5.0000	0.0000
			*MESH_VERTEX    1	25.0000	-5.0000	0.0000
			*MESH_VERTEX    2	15.0000	5.0000	0.0000
			*MESH_VERTEX    3	25.0000	5.0000	0.0000
			*MESH_VERTEX    4	15.0000	-5.0000	50.0000
			*MESH_VERTEX    5	25.0000	-5.0000	50.0000
			*MESH_VERTEX    6	15.0000	5.0000	50.0000
			*MESH_VERTEX    7	25.0000	5.0000	50.0000
		}
		*MESH_FACE_LIST {
			*MESH_FACE    0:    A:    0 B:    2 C:    3 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    1:    A:    3 B:    1 C:    0 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    2:    A:    4 B:    5 C:    7 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    3:    A:    7 B:    6 C:    4 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    4:    A:    0 B:    1 C:    5 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 4 	*MESH_MTLID 4
			*MESH_FACE    5:    A:    5 B:    4 C:    0 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 4 	*MESH_MTLID 4
			*MESH_FACE    6:    A:    1 B:    3 C:    7 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 5 	*MESH_MTLID 3
			*MESH_FACE    7:    A:    7 B:    5 C:    1 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 5 	*MESH_MTLID 3
			*MESH_FACE    8:    A:    3 B:    2 C:    6 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE    9:    A:    6 B:    7 C:    3 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE   10:    A:    2 B:    0 C:    4 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 7 	*MESH_MTLID 2
			*MESH_FACE   11:    A:    4 B:    6 C:    2 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 7 	*MESH_MTLID 2
		}
		*MESH_NUMTVERTEX 12
		*MESH_TVERTLIST {
			*MESH_TVERT 0	0.0000	0.0000	0.0000
			*MESH_TVERT 1	1.0000	0.0000	0.0000
			*MESH_TVERT 2	0.0000	1.0000	0.0000
			*MESH_TVERT 3	1.0000	1.0000	0.0000
			*MESH_TVERT 4	0.0000	0.0000	0.0000
			*MESH_TVERT 5	1.0000	0.0000	0.0000
			*MESH_TVERT 6	0.0000	1.0000	0.0000
			*MESH_TVERT 7	1.0000	1.0000	0.0000
			*MESH_TVERT 8	0.0000	0.0000	0.0000
			*MESH_TVERT 9	1.0000	0.0000	0.0000
			*MESH_TVERT 10	0.0000	1.0000	0.0000
			*MESH_TVERT 11	1.0000	1.0000	0.0000
		}
		*MESH_NUMTVFACES 12
		*MESH_TFACELIST {
			*MESH_TFACE 0	9	11	10
			*MESH_TFACE 1	10	8	9
			*MESH_TFACE 2	8	9	11
			*MESH_TFACE 3	11	10	8
			*MESH_TFACE 4	4	5	7
			*MESH_TFACE 5	7	6	4
			*MESH_TFACE 6	0	1	3
			*MESH_TFACE 7	3	2	0
			*MESH_TFACE 8	4	5	7
			*MESH_TFACE 9	7	6	4
			*MESH_TFACE 10	0	1	3
			*MESH_TFACE 11	3	2	0
		}
		*MESH_NUMCVERTEX 0
		*MESH_NORMALS {
			*MESH_FACENORMAL 0	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 0	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 2	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 3	0.0000	0.0000	-1.0000
			*MESH_FACENORMAL 1	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 3	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 1	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 0	0.0000	0.0000	-1.0000
			*MESH_FACENORMAL 2	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 4	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 5	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 7	0.0000	0.0000	1.0000
			*MESH_FACENORMAL 3	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 7	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 6	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 4	0.0000	0.0000	1.0000
			*MESH_FACENORMAL 4	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 0	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 1	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 5	0.0000	-1.0000	0.0000
			*MESH_FACENORMAL 5	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 5	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 4	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 0	0.0000	-1.0000	0.0000
			*MESH_FACENORMAL 6	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 1	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 3	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 7	1.0000	0.0000	0.0000
			*MESH_FACENORMAL 7	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 7	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 5	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 1	1.0000	0.0000	0.0000
			*MESH_FACENORMAL 8	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 3	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 2	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 6	0.0000	1.0000	0.0000
			*MESH_FACENORMAL 9	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 6	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 7	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 3	0.0000	1.0000	0.0000
			*MESH_FACENORMAL 10	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 2	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 0	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 4	-1.0000	0.0000	0.0000
			*MESH_FACENORMAL 11	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 4	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 6	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 2	-1.0000	0.0000	0.0000
		}
	}
	*PROP_MOTIONBLUR 0
	*PROP_CASTSHADOW 1
	*PROP_RECVSHADOW 1
	*WIREFRAME_COLOR 0.3412	0.8784	0.5608
}
*GEOMOBJECT {
	*NODE_NAME "Pyramid02"
	*NODE_PARENT "Box"
	*NODE_TM {
		*NODE_NAME "Pyramid02"
		*INHERIT_POS 0 0 0
		*INHERIT_ROT 0 0 0
		*INHERIT_SCL 0 0 0
		*TM_ROW0 1.0000	0.0000	0.0000
		*TM_ROW1 0.0000	1.0000	0.0000
		*TM_ROW2 0.0000	0.0000	1.0000
		*TM_ROW3 20.0000	0.0000	50.0000
		*TM_POS 20.0000	0.0000	50.0000
		*TM_ROTAXIS 0.0000	0.0000	0.0000
		*TM_ROTANGLE 0.0000
		*TM_SCALE 1.0000	1.0000	1.0000
		*TM_SCALEAXIS 0.0000	0.0000	0.0000
		*TM_SCALEAXISANG 0.0000
	}
	*MESH {
		*TIMEVALUE 0
		*MESH_NUMVERTEX 6
		*MESH_NUMFACES 8
		*MESH_VERTEX_LIST {
			*MESH_VERTEX    0	20.0000	0.0000	70.0000
			*MESH_VERTEX    1	10.0000	-10.0000	50.0000
			*MESH_VERTEX    2	30.0000	-10.0000	50.0000
			*MESH_VERTEX    3	30.0000	10.0000	50.0000
			*MESH_VERTEX    4	10.0000	10.0000	50.0000
			*MESH_VERTEX    5	20.0000	0.0000	50.0000
		}
		*MESH_FACE_LIST {
			*MESH_FACE    0:    A:    0 B:    1 C:    2 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    1:    A:    0 B:    2 C:    3 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 2 	*MESH_MTLID 0
			*MESH_FACE    2:    A:    0 B:    3 C:    4 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 5 	*MESH_MTLID 0
			*MESH_FACE    3:    A:    0 B:    4 C:    1 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 6 	*MESH_MTLID 0
			*MESH_FACE    4:    A:    1 B:    5 C:    2 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
			*MESH_FACE    5:    A:    2 B:    5 C:    3 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
			*MESH_FACE    6:    A:    3 B:    5 C:    4 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
			*MESH_FACE    7:    A:    4 B:    5 C:    1 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
		}
		*MESH_NUMTVERTEX 10
		*MESH_TVERTLIST {
			*MESH_TVERT 0	0.5000	1.0000	0.0000
			*MESH_TVERT 1	0.0000	0.0000	0.0000
			*MESH_TVERT 2	1.0000	0.0000	0.0000
			*MESH_TVERT 3	0.0000	0.0000	0.0000
			*MESH_TVERT 4	1.0000	0.0000	0.0000
			*MESH_TVERT 5	0.0000	1.0000	0.0000
			*MESH_TVERT 6	1.0000	1.0000	0.0000
			*MESH_TVERT 7	1.0000	0.0000	0.0000
			*MESH_TVERT 8	0.0000	0.0000	0.0000
			*MESH_TVERT 9	0.5000	0.5000	0.0000
		}
		*MESH_NUMTVFACES 8
		*MESH_TFACELIST {
			*MESH_TFACE 0	0	1	2
			*MESH_TFACE 1	0	3	4
			*MESH_TFACE 2	0	1	2
			*MESH_TFACE 3	0	3	4
			*MESH_TFACE 4	5	9	6
			*MESH_TFACE 5	6	9	7
			*MESH_TFACE 6	7	9	8
			*MESH_TFACE 7	8	9	5
		}
		*MESH_NUMCVERTEX 0
		*MESH_NORMALS {
			*MESH_FACENORMAL 0	0.0000	-0.8944	0.4472
				*MESH_VERTEXNORMAL 0	0.0000	-0.8944	0.4472
				*MESH_VERTEXNORMAL 1	0.0000	-0.8944	0.4472
				*MESH_VERTEXNORMAL 2	0.0000	-0.8944	0.4472
			*MESH_FACENORMAL 1	0.8944	0.0000	0.4472
				*MESH_VERTEXNORMAL 0	0.8944	0.0000	0.4472
				*MESH_VERTEXNORMAL 2	0.8944	0.0000	0.4472
				*MESH_VERTEXNORMAL 3	0.8944	0.0000	0.4472
			*MESH_FACENORMAL 2	0.0000	0.8944	0.4472
				*MESH_VERTEXNORMAL 0	0.0000	0.8944	0.4472
				*MESH_VERTEXNORMAL 3	0.0000	0.8944	0.4472
				*MESH_VERTEXNORMAL 4	0.0000	0.8944	0.4472
			*MESH_FACENORMAL 3	-0.8944	0.0000	0.4472
				*MESH_VERTEXNORMAL 0	-0.8944	0.0000	0.4472
				*MESH_VERTEXNORMAL 4	-0.8944	0.0000	0.4472
				*MESH_VERTEXNORMAL 1	-0.8944	0.0000	0.4472
			*MESH_FACENORMAL 4	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 1	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 5	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 2	0.0000	0.0000	-1.0000
			*MESH_FACENORMAL 5	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 2	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 5	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 3	0.0000	0.0000	-1.0000
			*MESH_FACENORMAL 6	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 3	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 5	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 4	0.0000	0.0000	-1.0000
			*MESH_FACENORMAL 7	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 4	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 5	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 1	0.0000	0.0000	-1.0000
		}
	}
	*PROP_MOTIONBLUR 0
	*PROP_CASTSHADOW 1
	*PROP_RECVSHADOW 1
	*WIREFRAME_COLOR 0.0235	0.5255	0.0235
}
'! !


!TMesh methodsFor: 'accessing' stamp: 'tak 5/30/2005 22:28'!
forceGlobalToLocalForASE
	"In ASE file, vertices and localTransform show both global coordinate. 
	And we have to make each vertices local"
	| invMat invOrient |
	invMat _ self localTransform orthoNormInverse.
	invOrient _ self orientation orthoNormInverse.
	1 to: vertexBuffer size
		do: [:index | vertexBuffer data at: index put: (invMat localPointToGlobal: (vertexBuffer data at: index))].
	1 to: normalBuffer size
		do: [:index | normalBuffer data at: index put: (invOrient localPointToGlobal: (normalBuffer data at: index))]! !


!TSampledAnimation methodsFor: 'accessing' stamp: 'tak 10/21/2004 14:23'!
clear
	self frame: nil.
	now _ 0.
	ticks _ nil.! !

!TSampledAnimation methodsFor: 'accessing' stamp: 'tak 9/28/2004 20:30'!
frame
	^ frame! !

!TSampledAnimation methodsFor: 'accessing' stamp: 'tak 9/28/2004 18:06'!
frame: aTFrame
	frame _ aTFrame.
	track _ nil! !

!TSampledAnimation methodsFor: 'accessing' stamp: 'tak 11/3/2004 22:16'!
isRepeat
	^ isRepeat! !

!TSampledAnimation methodsFor: 'accessing' stamp: 'tak 11/3/2004 22:16'!
isRepeat: aBoolean
	isRepeat _ aBoolean == true! !

!TSampledAnimation methodsFor: 'accessing' stamp: 'tak 10/21/2004 16:48'!
lastMoment
	^ self lastTick / tickspersecond * 1000! !

!TSampledAnimation methodsFor: 'accessing' stamp: 'tak 9/28/2004 21:04'!
lastTick
	^ self ticks max! !

!TSampledAnimation methodsFor: 'accessing' stamp: 'tak 10/12/2004 21:23'!
now
	| actualTicksIndex actualTick |
	actualTicksIndex _ (self ticks indexForInserting: now)
				- 1.
	actualTick _ actualTicksIndex > 0
				ifTrue: [self ticks at: actualTicksIndex]
				ifFalse: [self ticks first].
	^ actualTick! !

!TSampledAnimation methodsFor: 'accessing' stamp: 'tak 11/3/2004 22:19'!
now: aNumber 
	| actualTicksIndex actualTick num |
	num _ isRepeat
				ifTrue: [aNumber \\ self lastTick]
				ifFalse: [aNumber].
	actualTicksIndex _ (self ticks indexForInserting: num)
				- 1.
	actualTick _ actualTicksIndex > 0
				ifTrue: [self ticks at: actualTicksIndex]
				ifFalse: [self ticks first].
	"actualTick = now  
	ifTrue: [^ self]."
	(self track at: actualTick)
		keysAndValuesDo: [:node :transform | node localTransform: transform].
	now _ aNumber! !

!TSampledAnimation methodsFor: 'accessing' stamp: 'tak 10/16/2004 17:11'!
scale: aNumber 
	track _ nil.
	scenario
		keysAndValuesDo: [:tick :scenarioDict | scenarioDict
				keysAndValuesDo: [:nodeName :transform | transform translation: aNumber * transform translation]]! !

!TSampledAnimation methodsFor: 'accessing' stamp: 'tak 11/3/2004 22:18'!
stepAt: milisecond 
	| tickNumber |
	tickNumber _ (milisecond / 1000.0 * tickspersecond) asInteger.
	self now: tickNumber! !

!TSampledAnimation methodsFor: 'accessing' stamp: 'tak 9/28/2004 18:59'!
ticks
	^ ticks
		ifNil: [ticks _ self track keys asSortedCollection]
		ifNotNil: [ticks]! !

!TSampledAnimation methodsFor: 'fileIn/fileOut' stamp: 'tak 10/11/2004 20:47'!
prepareToExportOn: exporter 
	super prepareToExportOn: exporter.
	ticks _ nil.
	track _ nil.
! !

!TSampledAnimation methodsFor: 'building' stamp: 'tak 10/5/2004 23:35'!
addBuilder: builder 
	builder ticks
		do: [:tick | self
				tick: tick
				nodeName: builder nodeName
				transform: (builder transformAt: tick)]! !

!TSampledAnimation methodsFor: 'building' stamp: 'tak 9/28/2004 17:31'!
tick: aNumber nodeName: aString transform: matrix 
	| frameDict |
	ticks _ nil.
	frameDict _ scenario
				at: aNumber
				ifAbsentPut: [Dictionary new].
	frameDict at: aString put: matrix! !

!TSampledAnimation methodsFor: 'building' stamp: 'tak 10/11/2004 21:29'!
tickspersecond
	^ tickspersecond! !

!TSampledAnimation methodsFor: 'building' stamp: 'tak 10/5/2004 23:45'!
tickspersecond: aNumber
	tickspersecond _ aNumber! !

!TSampledAnimation methodsFor: 'private' stamp: 'tak 10/16/2004 16:55'!
track
	| foundFrames trackDict |
	track
		ifNotNil: [^ track].
	frame
		ifNil: [^ Dictionary new].
	track _ IdentityDictionary new.
	scenario
		keysAndValuesDo: [:tick :scenarioDict | 
			track at: tick put: (trackDict _ IdentityDictionary new).
			scenarioDict
				keysAndValuesDo: [:nodeName :transform | 
					foundFrames _ frame
								find: [:each | each objectName = nodeName].
					foundFrames size > 0
						ifTrue: [trackDict at: foundFrames first put: transform]]].
	^ track! !

!TSampledAnimation methodsFor: 'initialize' stamp: 'tak 11/3/2004 22:15'!
initialize
	super initialize.
	now _ 0.
	scenario _ Dictionary new.
	tickspersecond _ 100.
	isRepeat _ false.
! !


!TSampledAnimation class methodsFor: 'example' stamp: 'tak 11/3/2004 22:24'!
example1
	"TSampledAnimation example1"
	| animation |
	animation _ TSampledAnimation new.
	0
		to: 360
		by: 10
		do: [:i | animation
				tick: i
				nodeName: 'pot'
				transform: (B3DMatrix4x4 identity rotationAroundY: i)].
	animation
		frame: (TTeapot new objectName: 'pot').
	^ animation! !

!TSampledAnimation class methodsFor: 'example' stamp: 'tak 11/3/2004 22:27'!
showExample1
	"Show a teapot animation in current TeapotMorph"
	"TSampledAnimation showExample1"
	| animation frame |
	animation _ self example1.
	animation isRepeat: true.
	frame _ TAnimatedFrame new.
	frame animation: animation.
	CroquetGlobals theTeapotMorph activeCamera addFrameInFront: frame! !


!TSampledAnimationTest methodsFor: 'Testing' stamp: 'tak 10/18/2004 13:45'!
testAddScenario
	"self debug: #testAddScenario"
	| frame anime |
	frame _ TFrame new objectName: 'node'.
	anime _ TSampledAnimation new.
	anime
		tick: 0
		nodeName: 'node'
		transform: B3DMatrix4x4 identity.
	anime
		tick: 10
		nodeName: 'node'
		transform: (B3DMatrix4x4 identity rotationAroundZ: 90).
	anime frame: frame.
	self assert: anime ticks asArray = #(0 10 ).
	anime now: 10.
	self assert: frame localTransform
			= (B3DMatrix4x4 identity rotationAroundZ: 90).
	anime now: 0.
	self assert: frame localTransform
			= (B3DMatrix4x4 identity).! !

!TSampledAnimationTest methodsFor: 'Testing' stamp: 'tak 10/18/2004 12:30'!
testImportASE
	"self debug: #testImportASE"
	| max frame pyramid1 |
	max _ TLoad3DSMax new initializeOn: self class exampleSimpleTranslation readStream.
	frame _ max frame.
	pyramid1 _ (frame find: [ :e | e objectName = 'Pyramid01' ]) first.
	self assert: pyramid1 translation = (0 @ 0 @ 0).
	self assert: pyramid1 globalTransform rotation  = (-90 @ 0 @ 0).
	frame animation stepAt: 0.0.
	self assert: pyramid1 translation = (0 @ 0 @ 0).
	frame animation stepAt: 500.0.
	self assert: pyramid1 translation = (25 @ 25 @ 25).
	self assert: (pyramid1 globalTransform rotation - (-90 @ 0 @ 0)) length < 0.001.
! !

!TSampledAnimationTest methodsFor: 'Testing' stamp: 'tak 10/18/2004 12:29'!
testImportBone
	"self debug: #testImportBone"
	| max frame bone2 |
	max _ TLoad3DSMax new initializeOn: self class exampleBone readStream.
	frame _ max frame.
	bone2 _ (frame find: [ :e | e objectName = 'Bone02']) first.
	self assert: bone2 globalTransform translation = (0 @ 0 @ 50).
	frame animation stepAt: 0.0.
	self assert: (bone2 globalTransform translation - (0 @ 0 @ 50)) length < 0.001.
	frame animation stepAt: 1000.0. 
	self assert: (bone2 globalTransform translation - (0 @ 50 @ 0)) length < 0.001.
! !

!TSampledAnimationTest methodsFor: 'Testing' stamp: 'tak 10/18/2004 12:31'!
testImportDummy
	"self debug: #testImportDummy"
	| max frame box2 dummy |
	max _ TLoad3DSMax new initializeOn: self class exampleDummyObject readStream.
	frame _ max frame.
	box2 _ (frame find: [:each | each objectName = 'Box02']) first.
	dummy _ (frame find: [:each | each objectName = 'Dummy02']) first.
	self assert: dummy globalTransform translation = (0 @ 50 @ 0).
	frame animation stepAt: 0.
	self assert: dummy globalTransform translation = (0 @ 50 @ 0).
	frame animation stepAt: 500.
	self assert: dummy globalTransform translation = (25 @ 50 @ 0).
	self assert: box2 globalTransform translation = (25 @ 22.5 @ 0).
! !

!TSampledAnimationTest methodsFor: 'Testing' stamp: 'tak 10/9/2004 18:57'!
testImportScale
	"self debug: #testImportScale"
	| max frame box1 box2 |
	max _ TLoad3DSMax new initializeOn: self class exampleScale readStream.
	frame _ max frame.
	box1 _ frame frameChildren first.
	box2 _ box1 frameChildren first.
	self assert: box1 globalTransform translation = (0@0@0).
	self assert: box2 globalTransform translation = (30@0@0).
"	box1 localTransform copy inspect.
	box2 localTransform copy inspect."

	frame animation stepAt: 0.
	self assert: box1 globalTransform translation = (0@0@0).
	self assert: box2 globalTransform translation = (30@0@0).

	frame animation stepAt: 1000.
	self assert: box1 globalTransform translation = (20@0@0).
	self assert: box2 globalTransform translation = (30@0@0).

	frame animation stepAt: 1500.
	self assert: box1 globalTransform translation = (20@0@0).
	self assert: box2 globalTransform translation = (40@0@0).
! !

!TSampledAnimationTest methodsFor: 'Testing' stamp: 'tak 11/3/2004 22:37'!
testRepeat
	"self debug: #testRepeat"
	| animation frame |
	animation _ TSampledAnimation example1.
	frame _ animation frame.
	animation now: 0.
	self assert: frame localTransform rotation = (0 @ 0 @ 0).
	animation now: 90.
	self assert: frame localTransform rotation = (0 @ -90 @ 0).
	animation now: 420.
	self assert: (frame localTransform rotation - (0 @ 0 @ 0)) length < 0.001.
	animation isRepeat: true.
	animation now: 450.
	self assert: frame localTransform rotation = (0 @ -90 @ 0).
! !


!TSampledAnimationTest class methodsFor: 'test data' stamp: 'tak 10/18/2004 12:29'!
exampleBone
	"TLoad3DSMaxTest showMax: self exampleBone readStream"
	^
'*3DSMAX_ASCIIEXPORT	200
*COMMENT "AsciiExport Version  2.00 - Wed Oct 06 17:56:05 2004"
*SCENE {
	*SCENE_FILENAME "bone.max"
	*SCENE_FIRSTFRAME 0
	*SCENE_LASTFRAME 90
	*SCENE_FRAMESPEED 30
	*SCENE_TICKSPERFRAME 160
	*SCENE_BACKGROUND_STATIC 0.0000	0.0000	0.0000
	*SCENE_AMBIENT_STATIC 0.0000	0.0000	0.0000
}
*MATERIAL_LIST {
	*MATERIAL_COUNT 0
}
*GEOMOBJECT {
	*NODE_NAME "Bone01"
	*NODE_TM {
		*NODE_NAME "Bone01"
		*INHERIT_POS 1 1 1
		*INHERIT_ROT 1 1 1
		*INHERIT_SCL 1 1 1
		*TM_ROW0 -0.0000	-1.0000	0.0000
		*TM_ROW1 -0.0000	0.0000	1.0000
		*TM_ROW2 -1.0000	0.0000	-0.0000
		*TM_ROW3 0.0000	0.0000	0.0000
		*TM_POS 0.0000	0.0000	0.0000
		*TM_ROTAXIS 0.5774	-0.5774	-0.5774
		*TM_ROTANGLE 4.1888
		*TM_SCALE 1.0000	1.0000	1.0000
		*TM_SCALEAXIS 0.0000	0.0000	0.0000
		*TM_SCALEAXISANG 0.0000
	}
	*MESH {
		*TIMEVALUE 0
		*MESH_NUMVERTEX 9
		*MESH_NUMFACES 14
		*MESH_VERTEX_LIST {
			*MESH_VERTEX    0	-5.0000	-5.0000	-5.0000
			*MESH_VERTEX    1	-5.0000	-5.0000	5.0000
			*MESH_VERTEX    2	5.0000	-5.0000	5.0000
			*MESH_VERTEX    3	5.0000	-5.0000	-5.0000
			*MESH_VERTEX    4	-0.5000	-50.0000	-0.5000
			*MESH_VERTEX    5	-0.5000	-50.0000	0.5000
			*MESH_VERTEX    6	0.5000	-50.0000	0.5000
			*MESH_VERTEX    7	0.5000	-50.0000	-0.5000
			*MESH_VERTEX    8	0.0000	0.0000	0.0000
		}
		*MESH_FACE_LIST {
			*MESH_FACE    0:    A:    4 B:    7 C:    5 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 1 	*MESH_MTLID 0
			*MESH_FACE    1:    A:    6 B:    5 C:    7 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 1 	*MESH_MTLID 0
			*MESH_FACE    2:    A:    1 B:    5 C:    2 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    3:    A:    6 B:    2 C:    5 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    4:    A:    0 B:    4 C:    1 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 3 	*MESH_MTLID 2
			*MESH_FACE    5:    A:    5 B:    1 C:    4 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 3 	*MESH_MTLID 2
			*MESH_FACE    6:    A:    7 B:    3 C:    6 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 3
			*MESH_FACE    7:    A:    2 B:    6 C:    3 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 3
			*MESH_FACE    8:    A:    4 B:    0 C:    7 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 5 	*MESH_MTLID 4
			*MESH_FACE    9:    A:    3 B:    7 C:    0 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 5 	*MESH_MTLID 4
			*MESH_FACE   10:    A:    8 B:    0 C:    1 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE   11:    A:    8 B:    1 C:    2 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 7 	*MESH_MTLID 5
			*MESH_FACE   12:    A:    8 B:    2 C:    3 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 8 	*MESH_MTLID 5
			*MESH_FACE   13:    A:    8 B:    3 C:    0 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 9 	*MESH_MTLID 5
		}
	}
	*PROP_MOTIONBLUR 0
	*PROP_CASTSHADOW 1
	*PROP_RECVSHADOW 1
	*TM_ANIMATION {
		*NODE_NAME "Bone01"
		*CONTROL_ROT_TRACK {
			*CONTROL_ROT_SAMPLE 0	0.5774	-0.5774	-0.5774	4.1888
			*CONTROL_ROT_SAMPLE 800	-1.0000	0.0000	-0.0000	6.2065
			*CONTROL_ROT_SAMPLE 1600	1.0000	0.0000	-0.0000	0.2106
			*CONTROL_ROT_SAMPLE 2400	1.0000	-0.0000	0.0000	0.3027
			*CONTROL_ROT_SAMPLE 3200	1.0000	-0.0000	0.0000	0.3380
			*CONTROL_ROT_SAMPLE 4000	1.0000	0.0000	-0.0000	0.3340
			*CONTROL_ROT_SAMPLE 4800	1.0000	-0.0000	0.0000	0.3088
			*CONTROL_ROT_SAMPLE 5600	-1.0000	0.0000	-0.0000	0.3088
			*CONTROL_ROT_SAMPLE 6400	-1.0000	-0.0000	0.0000	0.3340
			*CONTROL_ROT_SAMPLE 7200	-1.0000	0.0000	-0.0000	0.3380
			*CONTROL_ROT_SAMPLE 8000	-1.0000	-0.0000	0.0000	0.3027
			*CONTROL_ROT_SAMPLE 8800	-1.0000	-0.0000	0.0000	0.2106
			*CONTROL_ROT_SAMPLE 9600	1.0000	-0.0000	0.0000	6.2065
		}
	}
	*WIREFRAME_COLOR 0.6824	0.7294	0.7961
}
*GEOMOBJECT {
	*NODE_NAME "Bone02"
	*NODE_PARENT "Bone01"
	*NODE_TM {
		*NODE_NAME "Bone02"
		*INHERIT_POS 1 1 1
		*INHERIT_ROT 1 1 1
		*INHERIT_SCL 1 1 1
		*TM_ROW0 0.0000	-0.0000	1.0000
		*TM_ROW1 0.0000	1.0000	0.0000
		*TM_ROW2 -1.0000	0.0000	0.0000
		*TM_ROW3 -0.0000	-50.0000	-0.0000
		*TM_POS -0.0000	-50.0000	-0.0000
		*TM_ROTAXIS -0.0000	1.0000	0.0000
		*TM_ROTANGLE 1.5708
		*TM_SCALE 1.0000	1.0000	1.0000
		*TM_SCALEAXIS 0.0000	0.0000	0.0000
		*TM_SCALEAXISANG 0.0000
	}
	*MESH {
		*TIMEVALUE 0
		*MESH_NUMVERTEX 9
		*MESH_NUMFACES 14
		*MESH_VERTEX_LIST {
			*MESH_VERTEX    0	-5.0000	-55.0000	5.0000
			*MESH_VERTEX    1	-5.0000	-45.0000	5.0000
			*MESH_VERTEX    2	5.0000	-45.0000	5.0000
			*MESH_VERTEX    3	5.0000	-55.0000	5.0000
			*MESH_VERTEX    4	-0.5000	-50.5000	50.0000
			*MESH_VERTEX    5	-0.5000	-49.5000	50.0000
			*MESH_VERTEX    6	0.5000	-49.5000	50.0000
			*MESH_VERTEX    7	0.5000	-50.5000	50.0000
			*MESH_VERTEX    8	-0.0000	-50.0000	-0.0000
		}
		*MESH_FACE_LIST {
			*MESH_FACE    0:    A:    4 B:    7 C:    5 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 1 	*MESH_MTLID 0
			*MESH_FACE    1:    A:    6 B:    5 C:    7 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 1 	*MESH_MTLID 0
			*MESH_FACE    2:    A:    1 B:    5 C:    2 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    3:    A:    6 B:    2 C:    5 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    4:    A:    0 B:    4 C:    1 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 3 	*MESH_MTLID 2
			*MESH_FACE    5:    A:    5 B:    1 C:    4 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 3 	*MESH_MTLID 2
			*MESH_FACE    6:    A:    7 B:    3 C:    6 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 3
			*MESH_FACE    7:    A:    2 B:    6 C:    3 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 3
			*MESH_FACE    8:    A:    4 B:    0 C:    7 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 5 	*MESH_MTLID 4
			*MESH_FACE    9:    A:    3 B:    7 C:    0 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 5 	*MESH_MTLID 4
			*MESH_FACE   10:    A:    8 B:    0 C:    1 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE   11:    A:    8 B:    1 C:    2 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 7 	*MESH_MTLID 5
			*MESH_FACE   12:    A:    8 B:    2 C:    3 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 8 	*MESH_MTLID 5
			*MESH_FACE   13:    A:    8 B:    3 C:    0 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 9 	*MESH_MTLID 5
		}
	}
	*PROP_MOTIONBLUR 0
	*PROP_CASTSHADOW 1
	*PROP_RECVSHADOW 1
	*TM_ANIMATION {
		*NODE_NAME "Bone02"
		*CONTROL_ROT_TRACK {
			*CONTROL_ROT_SAMPLE 0	-0.0000	-0.0000	-1.0000	1.5708
			*CONTROL_ROT_SAMPLE 800	0.0000	-0.0000	1.0000	0.0055
			*CONTROL_ROT_SAMPLE 1600	0.0000	0.0000	1.0000	0.0618
			*CONTROL_ROT_SAMPLE 2400	-0.0000	0.0000	1.0000	0.1854
			*CONTROL_ROT_SAMPLE 3200	0.0000	-0.0000	1.0000	0.3281
			*CONTROL_ROT_SAMPLE 4000	-0.0000	0.0000	1.0000	0.4493
			*CONTROL_ROT_SAMPLE 4800	0.0000	0.0000	1.0000	0.5407
			*CONTROL_ROT_SAMPLE 5600	-0.0000	-0.0000	-1.0000	0.5407
			*CONTROL_ROT_SAMPLE 6400	-0.0000	0.0000	-1.0000	0.4493
			*CONTROL_ROT_SAMPLE 7200	0.0000	-0.0000	-1.0000	0.3281
			*CONTROL_ROT_SAMPLE 8000	0.0000	0.0000	-1.0000	0.1854
			*CONTROL_ROT_SAMPLE 8800	0.0000	-0.0000	-1.0000	0.0618
			*CONTROL_ROT_SAMPLE 9600	-0.0000	-0.0000	-1.0000	0.0055
		}
	}
	*WIREFRAME_COLOR 0.6824	0.7294	0.7961
}
*GEOMOBJECT {
	*NODE_NAME "Bone03"
	*NODE_PARENT "Bone02"
	*NODE_TM {
		*NODE_NAME "Bone03"
		*INHERIT_POS 1 1 1
		*INHERIT_ROT 1 1 1
		*INHERIT_SCL 1 1 1
		*TM_ROW0 0.0000	-0.0000	1.0000
		*TM_ROW1 0.0000	1.0000	0.0000
		*TM_ROW2 -1.0000	0.0000	0.0000
		*TM_ROW3 0.0000	-50.0000	50.0000
		*TM_POS 0.0000	-50.0000	50.0000
		*TM_ROTAXIS 0.0000	1.0000	0.0000
		*TM_ROTANGLE 1.5708
		*TM_SCALE 1.0000	1.0000	1.0000
		*TM_SCALEAXIS 0.0000	0.0000	0.0000
		*TM_SCALEAXISANG 0.0000
	}
	*MESH {
		*TIMEVALUE 0
		*MESH_NUMVERTEX 9
		*MESH_NUMFACES 14
		*MESH_VERTEX_LIST {
			*MESH_VERTEX    0	-5.0000	-55.0000	55.0000
			*MESH_VERTEX    1	-5.0000	-45.0000	55.0000
			*MESH_VERTEX    2	5.0000	-45.0000	55.0000
			*MESH_VERTEX    3	5.0000	-55.0000	55.0000
			*MESH_VERTEX    4	-0.5000	-50.5000	60.0000
			*MESH_VERTEX    5	-0.5000	-49.5000	60.0000
			*MESH_VERTEX    6	0.5000	-49.5000	60.0000
			*MESH_VERTEX    7	0.5000	-50.5000	60.0000
			*MESH_VERTEX    8	0.0000	-50.0000	50.0000
		}
		*MESH_FACE_LIST {
			*MESH_FACE    0:    A:    4 B:    7 C:    5 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 1 	*MESH_MTLID 0
			*MESH_FACE    1:    A:    6 B:    5 C:    7 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 1 	*MESH_MTLID 0
			*MESH_FACE    2:    A:    1 B:    5 C:    2 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    3:    A:    6 B:    2 C:    5 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    4:    A:    0 B:    4 C:    1 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 3 	*MESH_MTLID 2
			*MESH_FACE    5:    A:    5 B:    1 C:    4 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 3 	*MESH_MTLID 2
			*MESH_FACE    6:    A:    7 B:    3 C:    6 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 3
			*MESH_FACE    7:    A:    2 B:    6 C:    3 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 3
			*MESH_FACE    8:    A:    4 B:    0 C:    7 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 5 	*MESH_MTLID 4
			*MESH_FACE    9:    A:    3 B:    7 C:    0 AB:    1 BC:    0 CA:    1	 *MESH_SMOOTHING 5 	*MESH_MTLID 4
			*MESH_FACE   10:    A:    8 B:    0 C:    1 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE   11:    A:    8 B:    1 C:    2 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 7 	*MESH_MTLID 5
			*MESH_FACE   12:    A:    8 B:    2 C:    3 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 8 	*MESH_MTLID 5
			*MESH_FACE   13:    A:    8 B:    3 C:    0 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 9 	*MESH_MTLID 5
		}
	}
	*PROP_MOTIONBLUR 0
	*PROP_CASTSHADOW 1
	*PROP_RECVSHADOW 1
	*WIREFRAME_COLOR 0.6824	0.7294	0.7961
}
'! !

!TSampledAnimationTest class methodsFor: 'test data' stamp: 'tak 10/18/2004 12:31'!
exampleDummyObject
	"TLoad3DSMaxTest showMax: self exampleDummyObject readStream"
	^
'*3DSMAX_ASCIIEXPORT	200
*COMMENT "AsciiExport Version  2.00 - Thu Oct 07 20:49:26 2004"
*SCENE {
	*SCENE_FILENAME "dummy.max"
	*SCENE_FIRSTFRAME 0
	*SCENE_LASTFRAME 60
	*SCENE_FRAMESPEED 30
	*SCENE_TICKSPERFRAME 160
	*SCENE_BACKGROUND_STATIC 0.0000	0.0000	0.0000
	*SCENE_AMBIENT_STATIC 0.0000	0.0000	0.0000
}
*MATERIAL_LIST {
	*MATERIAL_COUNT 0
}
*GEOMOBJECT {
	*NODE_NAME "Box01"
	*NODE_TM {
		*NODE_NAME "Box01"
		*INHERIT_POS 0 0 0
		*INHERIT_ROT 0 0 0
		*INHERIT_SCL 0 0 0
		*TM_ROW0 1.0000	0.0000	0.0000
		*TM_ROW1 0.0000	1.0000	0.0000
		*TM_ROW2 0.0000	0.0000	1.0000
		*TM_ROW3 0.0000	0.0000	0.0000
		*TM_POS 0.0000	0.0000	0.0000
		*TM_ROTAXIS 0.0000	0.0000	0.0000
		*TM_ROTANGLE 0.0000
		*TM_SCALE 1.0000	1.0000	1.0000
		*TM_SCALEAXIS 0.0000	0.0000	0.0000
		*TM_SCALEAXISANG 0.0000
	}
	*MESH {
		*TIMEVALUE 0
		*MESH_NUMVERTEX 8
		*MESH_NUMFACES 12
		*MESH_VERTEX_LIST {
			*MESH_VERTEX    0	-5.0000	-5.0000	0.0000
			*MESH_VERTEX    1	5.0000	-5.0000	0.0000
			*MESH_VERTEX    2	-5.0000	5.0000	0.0000
			*MESH_VERTEX    3	5.0000	5.0000	0.0000
			*MESH_VERTEX    4	-5.0000	-5.0000	50.0000
			*MESH_VERTEX    5	5.0000	-5.0000	50.0000
			*MESH_VERTEX    6	-5.0000	5.0000	50.0000
			*MESH_VERTEX    7	5.0000	5.0000	50.0000
		}
		*MESH_FACE_LIST {
			*MESH_FACE    0:    A:    0 B:    2 C:    3 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    1:    A:    3 B:    1 C:    0 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    2:    A:    4 B:    5 C:    7 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    3:    A:    7 B:    6 C:    4 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    4:    A:    0 B:    1 C:    5 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 4 	*MESH_MTLID 4
			*MESH_FACE    5:    A:    5 B:    4 C:    0 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 4 	*MESH_MTLID 4
			*MESH_FACE    6:    A:    1 B:    3 C:    7 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 5 	*MESH_MTLID 3
			*MESH_FACE    7:    A:    7 B:    5 C:    1 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 5 	*MESH_MTLID 3
			*MESH_FACE    8:    A:    3 B:    2 C:    6 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE    9:    A:    6 B:    7 C:    3 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE   10:    A:    2 B:    0 C:    4 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 7 	*MESH_MTLID 2
			*MESH_FACE   11:    A:    4 B:    6 C:    2 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 7 	*MESH_MTLID 2
		}
		*MESH_NUMTVERTEX 12
		*MESH_TVERTLIST {
			*MESH_TVERT 0	0.0000	0.0000	0.0000
			*MESH_TVERT 1	1.0000	0.0000	0.0000
			*MESH_TVERT 2	0.0000	1.0000	0.0000
			*MESH_TVERT 3	1.0000	1.0000	0.0000
			*MESH_TVERT 4	0.0000	0.0000	0.0000
			*MESH_TVERT 5	1.0000	0.0000	0.0000
			*MESH_TVERT 6	0.0000	1.0000	0.0000
			*MESH_TVERT 7	1.0000	1.0000	0.0000
			*MESH_TVERT 8	0.0000	0.0000	0.0000
			*MESH_TVERT 9	1.0000	0.0000	0.0000
			*MESH_TVERT 10	0.0000	1.0000	0.0000
			*MESH_TVERT 11	1.0000	1.0000	0.0000
		}
		*MESH_NUMTVFACES 12
		*MESH_TFACELIST {
			*MESH_TFACE 0	9	11	10
			*MESH_TFACE 1	10	8	9
			*MESH_TFACE 2	8	9	11
			*MESH_TFACE 3	11	10	8
			*MESH_TFACE 4	4	5	7
			*MESH_TFACE 5	7	6	4
			*MESH_TFACE 6	0	1	3
			*MESH_TFACE 7	3	2	0
			*MESH_TFACE 8	4	5	7
			*MESH_TFACE 9	7	6	4
			*MESH_TFACE 10	0	1	3
			*MESH_TFACE 11	3	2	0
		}
		*MESH_NUMCVERTEX 0
		*MESH_NORMALS {
			*MESH_FACENORMAL 0	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 0	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 2	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 3	0.0000	0.0000	-1.0000
			*MESH_FACENORMAL 1	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 3	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 1	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 0	0.0000	0.0000	-1.0000
			*MESH_FACENORMAL 2	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 4	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 5	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 7	0.0000	0.0000	1.0000
			*MESH_FACENORMAL 3	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 7	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 6	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 4	0.0000	0.0000	1.0000
			*MESH_FACENORMAL 4	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 0	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 1	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 5	0.0000	-1.0000	0.0000
			*MESH_FACENORMAL 5	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 5	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 4	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 0	0.0000	-1.0000	0.0000
			*MESH_FACENORMAL 6	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 1	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 3	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 7	1.0000	0.0000	0.0000
			*MESH_FACENORMAL 7	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 7	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 5	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 1	1.0000	0.0000	0.0000
			*MESH_FACENORMAL 8	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 3	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 2	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 6	0.0000	1.0000	0.0000
			*MESH_FACENORMAL 9	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 6	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 7	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 3	0.0000	1.0000	0.0000
			*MESH_FACENORMAL 10	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 2	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 0	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 4	-1.0000	0.0000	0.0000
			*MESH_FACENORMAL 11	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 4	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 6	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 2	-1.0000	0.0000	0.0000
		}
	}
	*PROP_MOTIONBLUR 0
	*PROP_CASTSHADOW 1
	*PROP_RECVSHADOW 1
	*WIREFRAME_COLOR 0.6039	0.8431	0.8980
}
*HELPEROBJECT {
	*NODE_NAME "Dummy02"
	*NODE_PARENT "Box01"
	*HELPER_CLASS "Dummy"
	*NODE_TM {
		*NODE_NAME "Dummy02"
		*INHERIT_POS 0 0 0
		*INHERIT_ROT 0 0 0
		*INHERIT_SCL 0 0 0
		*TM_ROW0 -0.0000	-1.0000	-0.0000
		*TM_ROW1 -0.0000	-0.0000	1.0000
		*TM_ROW2 -1.0000	0.0000	-0.0000
		*TM_ROW3 -0.0000	0.0000	50.0000
		*TM_POS -0.0000	0.0000	50.0000
		*TM_ROTAXIS 0.5774	-0.5774	-0.5774
		*TM_ROTANGLE 4.1888
		*TM_SCALE 1.0000	1.0000	1.0000
		*TM_SCALEAXIS 0.0000	0.0000	0.0000
		*TM_SCALEAXISANG 0.0000
	}
	*BOUNDINGBOX_MIN -5.2903	-5.2903	44.7097
	*BOUNDINGBOX_MAX 5.2903	5.2903	55.2903
	*TM_ANIMATION {
		*NODE_NAME "Dummy02"
		*CONTROL_POS_TRACK {
			*CONTROL_POS_SAMPLE 0	-0.0000	0.0000	50.0000
			*CONTROL_POS_SAMPLE 800	3.7037	0.0000	50.0000
			*CONTROL_POS_SAMPLE 1600	12.9630	0.0000	50.0000
			*CONTROL_POS_SAMPLE 2400	25.0000	0.0000	50.0000
			*CONTROL_POS_SAMPLE 3200	37.0370	0.0000	50.0000
			*CONTROL_POS_SAMPLE 4000	46.2963	0.0000	50.0000
			*CONTROL_POS_SAMPLE 4800	50.0000	0.0000	50.0000
		}
	}
}
*GEOMOBJECT {
	*NODE_NAME "Box02"
	*NODE_PARENT "Dummy02"
	*NODE_TM {
		*NODE_NAME "Box02"
		*INHERIT_POS 0 0 0
		*INHERIT_ROT 0 0 0
		*INHERIT_SCL 0 0 0
		*TM_ROW0 1.0000	-0.0000	0.0000
		*TM_ROW1 0.0000	1.0000	-0.0000
		*TM_ROW2 -0.0000	0.0000	1.0000
		*TM_ROW3 0.0000	0.0000	45.0000
		*TM_POS 0.0000	0.0000	45.0000
		*TM_ROTAXIS 0.0000	0.0000	0.0000
		*TM_ROTANGLE 0.0000
		*TM_SCALE 1.0000	1.0000	1.0000
		*TM_SCALEAXIS 0.0000	0.0000	0.0000
		*TM_SCALEAXISANG 0.0000
	}
	*MESH {
		*TIMEVALUE 0
		*MESH_NUMVERTEX 8
		*MESH_NUMFACES 12
		*MESH_VERTEX_LIST {
			*MESH_VERTEX    0	-5.0000	-5.0000	45.0000
			*MESH_VERTEX    1	5.0000	-5.0000	45.0000
			*MESH_VERTEX    2	-5.0000	5.0000	45.0000
			*MESH_VERTEX    3	5.0000	5.0000	45.0000
			*MESH_VERTEX    4	-5.0000	-5.0000	55.0000
			*MESH_VERTEX    5	5.0000	-5.0000	55.0000
			*MESH_VERTEX    6	-5.0000	5.0000	55.0000
			*MESH_VERTEX    7	5.0000	5.0000	55.0000
		}
		*MESH_FACE_LIST {
			*MESH_FACE    0:    A:    0 B:    2 C:    3 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    1:    A:    3 B:    1 C:    0 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    2:    A:    4 B:    5 C:    7 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    3:    A:    7 B:    6 C:    4 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    4:    A:    0 B:    1 C:    5 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 4 	*MESH_MTLID 4
			*MESH_FACE    5:    A:    5 B:    4 C:    0 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 4 	*MESH_MTLID 4
			*MESH_FACE    6:    A:    1 B:    3 C:    7 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 5 	*MESH_MTLID 3
			*MESH_FACE    7:    A:    7 B:    5 C:    1 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 5 	*MESH_MTLID 3
			*MESH_FACE    8:    A:    3 B:    2 C:    6 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE    9:    A:    6 B:    7 C:    3 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE   10:    A:    2 B:    0 C:    4 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 7 	*MESH_MTLID 2
			*MESH_FACE   11:    A:    4 B:    6 C:    2 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 7 	*MESH_MTLID 2
		}
		*MESH_NUMTVERTEX 12
		*MESH_TVERTLIST {
			*MESH_TVERT 0	0.0000	0.0000	0.0000
			*MESH_TVERT 1	1.0000	0.0000	0.0000
			*MESH_TVERT 2	0.0000	1.0000	0.0000
			*MESH_TVERT 3	1.0000	1.0000	0.0000
			*MESH_TVERT 4	0.0000	0.0000	0.0000
			*MESH_TVERT 5	1.0000	0.0000	0.0000
			*MESH_TVERT 6	0.0000	1.0000	0.0000
			*MESH_TVERT 7	1.0000	1.0000	0.0000
			*MESH_TVERT 8	0.0000	0.0000	0.0000
			*MESH_TVERT 9	1.0000	0.0000	0.0000
			*MESH_TVERT 10	0.0000	1.0000	0.0000
			*MESH_TVERT 11	1.0000	1.0000	0.0000
		}
		*MESH_NUMTVFACES 12
		*MESH_TFACELIST {
			*MESH_TFACE 0	9	11	10
			*MESH_TFACE 1	10	8	9
			*MESH_TFACE 2	8	9	11
			*MESH_TFACE 3	11	10	8
			*MESH_TFACE 4	4	5	7
			*MESH_TFACE 5	7	6	4
			*MESH_TFACE 6	0	1	3
			*MESH_TFACE 7	3	2	0
			*MESH_TFACE 8	4	5	7
			*MESH_TFACE 9	7	6	4
			*MESH_TFACE 10	0	1	3
			*MESH_TFACE 11	3	2	0
		}
		*MESH_NUMCVERTEX 0
		*MESH_NORMALS {
			*MESH_FACENORMAL 0	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 0	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 2	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 3	0.0000	0.0000	-1.0000
			*MESH_FACENORMAL 1	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 3	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 1	0.0000	0.0000	-1.0000
				*MESH_VERTEXNORMAL 0	0.0000	0.0000	-1.0000
			*MESH_FACENORMAL 2	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 4	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 5	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 7	0.0000	0.0000	1.0000
			*MESH_FACENORMAL 3	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 7	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 6	0.0000	0.0000	1.0000
				*MESH_VERTEXNORMAL 4	0.0000	0.0000	1.0000
			*MESH_FACENORMAL 4	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 0	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 1	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 5	0.0000	-1.0000	0.0000
			*MESH_FACENORMAL 5	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 5	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 4	0.0000	-1.0000	0.0000
				*MESH_VERTEXNORMAL 0	0.0000	-1.0000	0.0000
			*MESH_FACENORMAL 6	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 1	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 3	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 7	1.0000	0.0000	0.0000
			*MESH_FACENORMAL 7	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 7	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 5	1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 1	1.0000	0.0000	0.0000
			*MESH_FACENORMAL 8	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 3	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 2	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 6	0.0000	1.0000	0.0000
			*MESH_FACENORMAL 9	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 6	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 7	0.0000	1.0000	0.0000
				*MESH_VERTEXNORMAL 3	0.0000	1.0000	0.0000
			*MESH_FACENORMAL 10	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 2	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 0	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 4	-1.0000	0.0000	0.0000
			*MESH_FACENORMAL 11	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 4	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 6	-1.0000	0.0000	0.0000
				*MESH_VERTEXNORMAL 2	-1.0000	0.0000	0.0000
		}
	}
	*PROP_MOTIONBLUR 0
	*PROP_CASTSHADOW 1
	*PROP_RECVSHADOW 1
	*TM_ANIMATION {
		*NODE_NAME "Box02"
		*CONTROL_POS_TRACK {
			*CONTROL_POS_SAMPLE 0	0.0000	-5.0000	-0.0000
			*CONTROL_POS_SAMPLE 800	0.0000	-8.3333	-0.0000
			*CONTROL_POS_SAMPLE 1600	0.0000	-16.6667	-0.0000
			*CONTROL_POS_SAMPLE 2400	0.0000	-27.5000	-0.0000
			*CONTROL_POS_SAMPLE 3200	0.0000	-38.3333	-0.0000
			*CONTROL_POS_SAMPLE 4000	0.0000	-46.6667	0.0000
			*CONTROL_POS_SAMPLE 4800	0.0000	-50.0000	0.0000
		}
	}
	*WIREFRAME_COLOR 0.6941	0.1020	0.3451
}
'! !

!TSampledAnimationTest class methodsFor: 'test data' stamp: 'tak 10/18/2004 12:30'!
exampleScale
	"TLoad3DSMaxTest showMax: self exampleScale readStream"
^ '*3DSMAX_ASCIIEXPORT	200
*COMMENT "AsciiExport Version  2.00 - Sat Oct 09 15:54:06 2004"
*SCENE {
	*SCENE_FILENAME "scale.mzx.max"
	*SCENE_FIRSTFRAME 0
	*SCENE_LASTFRAME 90
	*SCENE_FRAMESPEED 30
	*SCENE_TICKSPERFRAME 160
	*SCENE_BACKGROUND_STATIC 0.0000	0.0000	0.0000
	*SCENE_AMBIENT_STATIC 0.0000	0.0000	0.0000
}
*MATERIAL_LIST {
	*MATERIAL_COUNT 0
}
*GEOMOBJECT {
	*NODE_NAME "Box01"
	*NODE_TM {
		*NODE_NAME "Box01"
		*INHERIT_POS 0 0 0
		*INHERIT_ROT 0 0 0
		*INHERIT_SCL 0 0 0
		*TM_ROW0 0.5000	0.0000	0.0000
		*TM_ROW1 0.0000	-0.0000	0.5000
		*TM_ROW2 0.0000	-0.5000	-0.0000
		*TM_ROW3 0.0000	-0.0000	0.0000
		*TM_POS 0.0000	-0.0000	0.0000
		*TM_ROTAXIS -1.0000	0.0000	0.0000
		*TM_ROTANGLE 1.5708
		*TM_SCALE 0.5000	0.5000	0.5000
		*TM_SCALEAXIS 0.0000	0.0000	0.0000
		*TM_SCALEAXISANG 0.0000
	}
	*MESH {
		*TIMEVALUE 0
		*MESH_NUMVERTEX 8
		*MESH_NUMFACES 12
		*MESH_VERTEX_LIST {
			*MESH_VERTEX    0	-5.0000	-0.0000	-5.0000
			*MESH_VERTEX    1	5.0000	-0.0000	-5.0000
			*MESH_VERTEX    2	-5.0000	-0.0000	5.0000
			*MESH_VERTEX    3	5.0000	-0.0000	5.0000
			*MESH_VERTEX    4	-5.0000	-10.0000	-5.0000
			*MESH_VERTEX    5	5.0000	-10.0000	-5.0000
			*MESH_VERTEX    6	-5.0000	-10.0000	5.0000
			*MESH_VERTEX    7	5.0000	-10.0000	5.0000
		}
		*MESH_FACE_LIST {
			*MESH_FACE    0:    A:    0 B:    2 C:    3 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    1:    A:    3 B:    1 C:    0 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    2:    A:    4 B:    5 C:    7 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    3:    A:    7 B:    6 C:    4 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    4:    A:    0 B:    1 C:    5 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 4 	*MESH_MTLID 4
			*MESH_FACE    5:    A:    5 B:    4 C:    0 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 4 	*MESH_MTLID 4
			*MESH_FACE    6:    A:    1 B:    3 C:    7 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 5 	*MESH_MTLID 3
			*MESH_FACE    7:    A:    7 B:    5 C:    1 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 5 	*MESH_MTLID 3
			*MESH_FACE    8:    A:    3 B:    2 C:    6 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE    9:    A:    6 B:    7 C:    3 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE   10:    A:    2 B:    0 C:    4 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 7 	*MESH_MTLID 2
			*MESH_FACE   11:    A:    4 B:    6 C:    2 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 7 	*MESH_MTLID 2
		}
	}
	*PROP_MOTIONBLUR 0
	*PROP_CASTSHADOW 1
	*PROP_RECVSHADOW 1
	*TM_ANIMATION {
		*NODE_NAME "Box01"
		*CONTROL_POS_TRACK {
			*CONTROL_POS_SAMPLE 0	0.0000	-0.0000	0.0000
			*CONTROL_POS_SAMPLE 800	1.4815	-0.0000	0.0000
			*CONTROL_POS_SAMPLE 1600	5.1852	-0.0000	0.0000
			*CONTROL_POS_SAMPLE 2400	10.0000	-0.0000	0.0000
			*CONTROL_POS_SAMPLE 3200	14.8148	-0.0000	0.0000
			*CONTROL_POS_SAMPLE 4000	18.5185	-0.0000	0.0000
			*CONTROL_POS_SAMPLE 4800	20.0000	-0.0000	0.0000
		}
	}
	*WIREFRAME_COLOR 0.1098	0.5843	0.6941
}
*GEOMOBJECT {
	*NODE_NAME "Box02"
	*NODE_PARENT "Box01"
	*NODE_TM {
		*NODE_NAME "Box02"
		*INHERIT_POS 0 0 0
		*INHERIT_ROT 0 0 0
		*INHERIT_SCL 0 0 0
		*TM_ROW0 1.0000	0.0000	0.0000
		*TM_ROW1 0.0000	-0.0000	1.0000
		*TM_ROW2 0.0000	-1.0000	-0.0000
		*TM_ROW3 30.0000	-0.0000	0.0000
		*TM_POS 30.0000	-0.0000	0.0000
		*TM_ROTAXIS -1.0000	0.0000	0.0000
		*TM_ROTANGLE 1.5708
		*TM_SCALE 1.0000	1.0000	1.0000
		*TM_SCALEAXIS 0.0000	0.0000	0.0000
		*TM_SCALEAXISANG 0.0000
	}
	*MESH {
		*TIMEVALUE 0
		*MESH_NUMVERTEX 8
		*MESH_NUMFACES 12
		*MESH_VERTEX_LIST {
			*MESH_VERTEX    0	25.0000	-0.0000	-5.0000
			*MESH_VERTEX    1	35.0000	-0.0000	-5.0000
			*MESH_VERTEX    2	25.0000	-0.0000	5.0000
			*MESH_VERTEX    3	35.0000	-0.0000	5.0000
			*MESH_VERTEX    4	25.0000	-10.0000	-5.0000
			*MESH_VERTEX    5	35.0000	-10.0000	-5.0000
			*MESH_VERTEX    6	25.0000	-10.0000	5.0000
			*MESH_VERTEX    7	35.0000	-10.0000	5.0000
		}
		*MESH_FACE_LIST {
			*MESH_FACE    0:    A:    0 B:    2 C:    3 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    1:    A:    3 B:    1 C:    0 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 2 	*MESH_MTLID 1
			*MESH_FACE    2:    A:    4 B:    5 C:    7 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    3:    A:    7 B:    6 C:    4 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    4:    A:    0 B:    1 C:    5 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 4 	*MESH_MTLID 4
			*MESH_FACE    5:    A:    5 B:    4 C:    0 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 4 	*MESH_MTLID 4
			*MESH_FACE    6:    A:    1 B:    3 C:    7 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 5 	*MESH_MTLID 3
			*MESH_FACE    7:    A:    7 B:    5 C:    1 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 5 	*MESH_MTLID 3
			*MESH_FACE    8:    A:    3 B:    2 C:    6 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE    9:    A:    6 B:    7 C:    3 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 6 	*MESH_MTLID 5
			*MESH_FACE   10:    A:    2 B:    0 C:    4 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 7 	*MESH_MTLID 2
			*MESH_FACE   11:    A:    4 B:    6 C:    2 AB:    1 BC:    1 CA:    0	 *MESH_SMOOTHING 7 	*MESH_MTLID 2
		}
	}
	*PROP_MOTIONBLUR 0
	*PROP_CASTSHADOW 1
	*PROP_RECVSHADOW 1
	*TM_ANIMATION {
		*NODE_NAME "Box02"
		*CONTROL_POS_TRACK {
			*CONTROL_POS_SAMPLE 0	60.0000	0.0000	0.0000
			*CONTROL_POS_SAMPLE 800	57.0370	0.0000	0.0000
			*CONTROL_POS_SAMPLE 1600	49.6296	0.0000	0.0000
			*CONTROL_POS_SAMPLE 2400	40.0000	0.0000	0.0000
			*CONTROL_POS_SAMPLE 3200	30.3704	0.0000	0.0000
			*CONTROL_POS_SAMPLE 4000	22.9630	0.0000	0.0000
			*CONTROL_POS_SAMPLE 4800	20.0000	0.0000	0.0000
			*CONTROL_POS_SAMPLE 5600	22.9630	0.0000	0.0000
			*CONTROL_POS_SAMPLE 6400	30.3704	0.0000	0.0000
			*CONTROL_POS_SAMPLE 7200	40.0000	0.0000	0.0000
			*CONTROL_POS_SAMPLE 8000	49.6296	0.0000	0.0000
			*CONTROL_POS_SAMPLE 8800	57.0370	0.0000	0.0000
			*CONTROL_POS_SAMPLE 9600	60.0000	0.0000	0.0000
		}
	}
	*WIREFRAME_COLOR 0.5529	0.0275	0.2275
}
'! !

!TSampledAnimationTest class methodsFor: 'test data' stamp: 'tak 10/18/2004 12:30'!
exampleSimpleTranslation
	"TLoad3DSMaxTest showMax: self exampleSimpleTranslation readStream"
	^
'*3DSMAX_ASCIIEXPORT	200
*COMMENT "AsciiExport Version  2.00 - Wed Oct 06 12:44:59 2004"
*SCENE {
	*SCENE_FILENAME "simpleTranslation.max"
	*SCENE_FIRSTFRAME 0
	*SCENE_LASTFRAME 10
	*SCENE_FRAMESPEED 10
	*SCENE_TICKSPERFRAME 480
	*SCENE_BACKGROUND_STATIC 0.0000	0.0000	0.0000
	*SCENE_AMBIENT_STATIC 0.0000	0.0000	0.0000
}
*MATERIAL_LIST {
	*MATERIAL_COUNT 0
}
*GEOMOBJECT {
	*NODE_NAME "Pyramid01"
	*NODE_TM {
		*NODE_NAME "Pyramid01"
		*INHERIT_POS 0 0 0
		*INHERIT_ROT 0 0 0
		*INHERIT_SCL 0 0 0
		*TM_ROW0 1.0000	0.0000	0.0000
		*TM_ROW1 0.0000	0.0000	1.0000
		*TM_ROW2 0.0000	-1.0000	0.0000
		*TM_ROW3 0.0000	0.0000	0.0000
		*TM_POS 0.0000	0.0000	0.0000
		*TM_ROTAXIS -1.0000	0.0000	0.0000
		*TM_ROTANGLE 1.5708
		*TM_SCALE 1.0000	1.0000	1.0000
		*TM_SCALEAXIS 0.0000	0.0000	0.0000
		*TM_SCALEAXISANG 0.0000
	}
	*MESH {
		*TIMEVALUE 0
		*MESH_NUMVERTEX 6
		*MESH_NUMFACES 8
		*MESH_VERTEX_LIST {
			*MESH_VERTEX    0	0.0000	-10.0000	0.0000
			*MESH_VERTEX    1	-5.0000	-0.0000	-5.0000
			*MESH_VERTEX    2	5.0000	-0.0000	-5.0000
			*MESH_VERTEX    3	5.0000	0.0000	5.0000
			*MESH_VERTEX    4	-5.0000	0.0000	5.0000
			*MESH_VERTEX    5	0.0000	0.0000	0.0000
		}
		*MESH_FACE_LIST {
			*MESH_FACE    0:    A:    0 B:    1 C:    2 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 3 	*MESH_MTLID 0
			*MESH_FACE    1:    A:    0 B:    2 C:    3 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 2 	*MESH_MTLID 0
			*MESH_FACE    2:    A:    0 B:    3 C:    4 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 5 	*MESH_MTLID 0
			*MESH_FACE    3:    A:    0 B:    4 C:    1 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 6 	*MESH_MTLID 0
			*MESH_FACE    4:    A:    1 B:    5 C:    2 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
			*MESH_FACE    5:    A:    2 B:    5 C:    3 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
			*MESH_FACE    6:    A:    3 B:    5 C:    4 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
			*MESH_FACE    7:    A:    4 B:    5 C:    1 AB:    1 BC:    1 CA:    1	 *MESH_SMOOTHING 4 	*MESH_MTLID 0
		}
	}
	*PROP_MOTIONBLUR 0
	*PROP_CASTSHADOW 1
	*PROP_RECVSHADOW 1
	*TM_ANIMATION {
		*NODE_NAME "Pyramid01"
		*CONTROL_POS_TRACK {
			*CONTROL_POS_SAMPLE 0	0.0000	0.0000	0.0000
			*CONTROL_POS_SAMPLE 480	1.4000	-1.4000	1.4000
			*CONTROL_POS_SAMPLE 960	5.2000	-5.2000	5.2000
			*CONTROL_POS_SAMPLE 1440	10.8000	-10.8000	10.8000
			*CONTROL_POS_SAMPLE 1920	17.6000	-17.6000	17.6000
			*CONTROL_POS_SAMPLE 2400	25.0000	-25.0000	25.0000
			*CONTROL_POS_SAMPLE 2880	32.4000	-32.4000	32.4000
			*CONTROL_POS_SAMPLE 3360	39.2000	-39.2000	39.2000
			*CONTROL_POS_SAMPLE 3840	44.8000	-44.8000	44.8000
			*CONTROL_POS_SAMPLE 4320	48.6000	-48.6000	48.6000
			*CONTROL_POS_SAMPLE 4800	50.0000	-50.0000	50.0000
		}
	}
	*WIREFRAME_COLOR 0.8784	0.7765	0.3412
}
'! !


!TUserCamera methodsFor: 'drag and drop' stamp: 'tak 11/3/2004 22:11'!
addFrameInFront: tframe 
	tframe translation: self translation - (self lookAt * 6).
	self currentSpace addChild: tframe.
	^ tframe! !

TMesh removeSelector: #forceGlobalToLocal!
TLoad3DSMax removeSelector: #makeGroup:!
TLoad3DSMax removeSelector: #makeHelperObject:!
TLoad3DSMax removeSelector: #makeNodeName:!
TFrame subclass: #TLoad3DSMax
	instanceVariableNames: 'vertices tvertices faces tfaces matIndex stringLoc materialList materialRef textureList scale shadeAngle shadeAngleCos frame textureMode transform inverseTransform aheadChar filePath meshFaceNormals meshFaceVertexNormals barCount objects animationBuilder linearScale '
	classVariableNames: 'DelimSet1 DelimSet2 DelimSet3 NumberSet WhiteSpaceSet '
	poolDictionaries: 'OpenGLConstants '
	category: 'Croquet-Objects'!
TFrame removeSelector: #forceGlobalToLocal!
TFrame removeSelector: #prune!
