'From Jasmine-rc1 of 7 October 2004 [latest update: #192] on 3 January 2005 at 9:23:32 pm'!
TAvatar subclass: #CRAvatar
	instanceVariableNames: 'status lastTime timePoint nextStatus animations '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChainReaction'!

!CRAvatar commentStamp: 'tak 10/22/2004 10:57' prior: 0!
I am an avatar of Chain Reaction character.
My animaiton is work like state machine.!

TSpace subclass: #CRSpace
	instanceVariableNames: 'soldier '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChainReaction'!

!CRSpace commentStamp: 'tak 10/22/2004 10:57' prior: 0!
I am a space for Chain Reaction.
I handle keyboard myself.!

TeapotMorph subclass: #CRTeapotMorph
	instanceVariableNames: 'initMode '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChainReaction'!

!CRTeapotMorph commentStamp: 'tak 10/22/2004 10:59' prior: 0!
I am an entry point for Chain Reaction.
I have also resource loading method as class method for the models.
!


!CRAvatar methodsFor: 'initialize' stamp: 'tak 10/22/2004 20:58'!
initialize
	super initialize.
	lastTime _  TeaTime now asFloat.
	timePoint _ 0.
	animations _ IdentityDictionary new.
! !

!CRAvatar methodsFor: 'initialize' stamp: 'tak 12/26/2004 15:16'!
initializeForSoldier
	| tframe |
	tframe _ CRTeapotMorph loadSoldier.
	tframe localTransform: B3DMatrix4x4 identity.
	tframe rotationAroundY: 180.
	tframe translation: 0 @ height negated @ 0.
	tframe singleParent: false.
	tframe solidTree: false.
	tframe objectOwner: nil.
	self costume: tframe.
	status _ #stop.
	nextStatus _ #stop.
	animations
		at: #walk
		put: (CRTeapotMorph loadAnimationWalk frame: tframe).
	animations
		at: #death
		put: (CRTeapotMorph loadAnimationDeath frame: tframe)! !

!CRAvatar methodsFor: 'accessing' stamp: 'tak 10/21/2004 16:02'!
driving
	^ true! !

!CRAvatar methodsFor: 'accessing' stamp: 'tak 10/21/2004 16:10'!
nextStatus: aSymbol
	nextStatus _ aSymbol! !

!CRAvatar methodsFor: 'accessing' stamp: 'tak 10/21/2004 17:55'!
speedControl: sc pointerTransform: trans

	speedControl _ sc * 3.
	self pointerTransform: trans.! !

!CRAvatar methodsFor: 'accessing' stamp: 'tak 10/21/2004 16:11'!
startDriving: yControlsPitch
	super startDriving: yControlsPitch.
	self nextStatus: #walk! !

!CRAvatar methodsFor: 'accessing' stamp: 'tak 10/21/2004 16:11'!
stopDriving
	super stopDriving.
	self nextStatus: #stop! !

!CRAvatar methodsFor: 'driving' stamp: 'tak 11/3/2004 23:38'!
death
	| isChanged animation delta |
	isChanged _ false.
	delta _ TeaTime now asFloat - lastTime.
	timePoint _ timePoint + delta.
	animation _ animations at: #death.
	(timePoint > animation lastMoment
			and: [nextStatus == #walk])
		ifTrue: [isChanged _ true].
	animation stepAt: timePoint.
	isChanged
		ifTrue: [timePoint _ animation lastMoment.
			status _ #revive]! !

!CRAvatar methodsFor: 'driving' stamp: 'tak 10/21/2004 17:29'!
driveStep
	(#(#death #revive #stop #walk ) includes: status)
		ifTrue: [self perform: status].
	lastTime _ TeaTime now asFloat.
	super driveStep! !

!CRAvatar methodsFor: 'driving' stamp: 'tak 10/21/2004 17:34'!
revive
	| isChanged animation delta |
	isChanged _ false.
	delta _ TeaTime now asFloat - lastTime.
	timePoint _ timePoint - delta.
	animation _ animations at: #death.
	timePoint < 0
		ifTrue: [isChanged _ true].
	animation
		stepAt: (timePoint max: 0).
	isChanged
		ifTrue: [timePoint _ 0.
			status _ nextStatus]! !

!CRAvatar methodsFor: 'driving' stamp: 'tak 10/21/2004 16:46'!
stop
	status _ nextStatus.
! !

!CRAvatar methodsFor: 'driving' stamp: 'tak 10/21/2004 17:56'!
walk
	| isChanged animation delta |
	speedControl ifNil: [^self].
	isChanged _ false.
	delta _ TeaTime now asFloat - lastTime * speedControl length * 1.5.
	delta _ speedControl y sign * delta.
	timePoint _ timePoint + delta.
	animation _ animations at: #walk.
	nextStatus == #death ifTrue: [isChanged _ true].
	((0 > timePoint
				or: [timePoint > animation lastMoment])
			and: [nextStatus ~~ #walk])
		ifTrue: [isChanged _ true].
	timePoint _ timePoint \\ animation lastMoment.
	animation stepAt: timePoint.
	isChanged
		ifTrue: [timePoint _ 0.
			status _ nextStatus].
! !


!CRSpace methodsFor: 'events' stamp: 'tak 10/12/2004 16:58'!
handlesKeyboard: pointer 
	^ true! !

!CRSpace methodsFor: 'events' stamp: 'tak 10/21/2004 17:20'!
keyStroke: pointer 
	| anEvent |
	anEvent _ pointer event2D.
	"Transcript cr; show: anEvent keyValue inspect."
	(anEvent controlKeyPressed
			and: [anEvent keyValue = 1])
		ifTrue: [pointer camera toggleAvatarPerson.
			^ self].
	anEvent keyCharacter = $ 
		ifTrue: [pointer camera avatar nextStatus: #death].
	soldier
		ifNil: [^ self].
	anEvent keyValue = 28
		ifTrue: [soldier left].
	anEvent keyValue = 29
		ifTrue: [soldier right].
	anEvent keyValue = 30
		ifTrue: [soldier forward].
	anEvent keyValue = 31
		ifTrue: [soldier back].
! !


!CRTeapotMorph methodsFor: 'accessing' stamp: 'tak 10/22/2004 11:43'!
initMode: aSymbol 
	initMode _ aSymbol! !

!CRTeapotMorph methodsFor: 'initialization' stamp: 'tak 10/22/2004 11:42'!
initialize
	super initialize.
	initMode _ #makeSpaceFull! !

!CRTeapotMorph methodsFor: 'initialization' stamp: 'tak 10/22/2004 11:42'!
initializeDefaultSpace
	^ self perform: initMode.! !

!CRTeapotMorph methodsFor: 'initialization' stamp: 'tak 10/22/2004 21:38'!
makeSpaceFull
	| space |
	space _ CRSpace new.
	activeCamera avatar enter: space.
	self world doOneCycleNow.
	self makeLight: space.
	self world doOneCycleNow.
	self makeAvatar: space.
	self world doOneCycleNow.
	self makeStage: space.
	self world doOneCycleNow.
"	self makeCubes: space."
	self makeDrone: space.

	^ space! !

!CRTeapotMorph methodsFor: 'initialization' stamp: 'tak 10/22/2004 21:38'!
makeSpaceSimple
	| space |
	space _ CRSpace new.
	activeCamera avatar enter: space.
	self world doOneCycleNow.
	self makeLight: space.
	self world doOneCycleNow.
	self makeAvatar: space.
	self makeFloor: space fileName: 'stone.BMP'.
	self makeACube: space.
	self makeDrone: space.
	^ space! !

!CRTeapotMorph methodsFor: 'toys' stamp: 'tak 10/22/2004 21:31'!
makeACube: sp 
	| cube |
	cube _ CroquetData
				loadURL: 'http://www.reed.com/TeaLand/ChainReaction/cube.tea'
				ifAbsentPut: [cube _ (TLoad3DSMax new initializeWithFileName: #('Content' 'ChainReaction' 'Cube.ASE' ) asPath scale: 1.0) frame.
					cube initBounds.
					cube].
	cube translation: 0 @0 @0.
	sp addChild: cube! !

!CRTeapotMorph methodsFor: 'toys' stamp: 'tak 12/27/2004 21:51'!
makeAvatar: space 
	| avatar oldAvatar |
	self world doOneCycleNow.
	oldAvatar _ activeCamera avatar.
	avatar _ CRAvatar new.
	avatar initializeForSoldier.
	activeCamera avatar: avatar.
	space addChild: avatar.
	avatar translation: 0 @ 0 @ 30.
"	activeCamera thirdPerson: 5."
	space removeChild: oldAvatar.! !

!CRTeapotMorph methodsFor: 'toys' stamp: 'tak 10/22/2004 21:31'!
makeCubes: sp 
	| cube layout newCube |
	self world doOneCycleNow.
	cube _ CroquetData
				loadURL: 'http://www.reed.com/TeaLand/ChainReaction/cube.tea'
				ifAbsentPut: [cube _ (TLoad3DSMax new initializeWithFileName: #('Content' 'ChainReaction' 'Cube.ASE' ) asPath scale: 1.0) frame.
					cube initBounds.
					cube].
	layout _ CroquetData
				loadURL: 'http://www.reed.com/TeaLand/ChainReaction/cubeLayout.tea'
				ifAbsentPut: [layout _ (TLoad3DSMax new initializeWithFileName: #('Content' 'ChainReaction' 'cube_layout_concept.ASE' ) asPath scale: 1.0) frame.
					layout initBounds.
					layout].
	layout frameChildren
		do: [:child | 
			newCube _ cube copy localTransform: child localTransform.
			sp addChild: newCube]! !

!CRTeapotMorph methodsFor: 'toys' stamp: 'tak 10/22/2004 21:42'!
makeDrone: sp 
	| drone |
	drone _ CRTeapotMorph loadDrone.
	drone translation: 0 @ 40 @0.
	sp addChild: drone! !

!CRTeapotMorph methodsFor: 'toys' stamp: 'tak 10/22/2004 21:31'!
makeStage: sp 
	| tframe f |
	self world doOneCycleNow.
	sp url: 'http://www.reed.com/TeaLand/ChainReaction/ChainReaction.tea'.
	tframe _ CroquetData
				loadURL: 'http://www.reed.com/TeaLand/ChainReaction/arena.tea'
				ifAbsentPut: [f _ (TLoad3DSMax new initializeWithFileName: #('Content' 'ChainReaction' 'Level_outof6.ASE' ) asPath scale: 1.0) frame.
					f boundsDepth: 2.
					f initBounds.
					f].
	self makeCubes: tframe.

	TQuadTree new initializeWithSpace: sp frame: tframe.
	tframe translation: 0 @ 0 @ 0! !


!CRTeapotMorph class methodsFor: 'parts bin' stamp: 'tak 10/12/2004 13:26'!
descriptionForPartsBin
	^ self partName:	'ChainReaction'
		categories:		#('Croquet')
		documentation:	'Chain Reaction'
		sampleImageForm: (Form extent: 64@64 depth: 32 bits: (Bitmap decompressFromByteArray: (Base64MimeConverter mimeDecode: ' 8ABC/wAAAAv/FhYW/wICAuD2/wAAABP/QEBA/+zs7P/Z2dn/TU1N4O7/AAAAC/8RERH/xsbG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' as: String) asByteArray)).
! !

!CRTeapotMorph class methodsFor: 'resource' stamp: 'tak 11/4/2004 00:23'!
loadAnimationDeath
	"self loadAnimationDeath"
	| animation death fName |
	^ CroquetData
		loadURL: 'http://www.reed.com/TeaLand/ChainReaction/anime-death.tea'
		ifAbsentPut: [fName _ #('Content' 'ChainReaction' 'death-2004-10-11.ASE' ) asPath.
			animation _ TLoad3DSMax new initializeWithFileName: fName scale: 0.02.
			death _ animation frame animation.
			death isRepeat: false.
			death clear; yourself]! !

!CRTeapotMorph class methodsFor: 'resource' stamp: 'tak 11/4/2004 00:24'!
loadAnimationWalk
	"self loadAnimationWalk"
	| max walk fName |
	^ CroquetData
		loadURL: 'http://www.reed.com/TeaLand/ChainReaction/anime-walk.tea'
		ifAbsentPut: [fName _ #('Content' 'ChainReaction' 'walk-2004-10-11.ASE' ) asPath.
			max _ TLoad3DSMax new initializeWithFileName: fName scale: 0.02.
			walk _ max frame animation.
			walk isRepeat: false.
			walk clear; yourself]! !

!CRTeapotMorph class methodsFor: 'resource' stamp: 'tak 10/22/2004 21:35'!
loadDrone
	"self loadDrone"
	| fName max tframe |
	^ CroquetData
		loadURL: 'http://www.reed.com/TeaLand/ChainReaction/drone.tea'
		ifAbsentPut: [fName _ #('Content' 'ChainReaction' 'Drone-2004-10-09.ASE' ) asPath.
			max _ TLoad3DSMax new initializeWithFileName: fName scale: 1.0.
			tframe _ max frame.
			tframe boundsDepth: 2.
			tframe initBounds.
			tframe]! !

!CRTeapotMorph class methodsFor: 'resource' stamp: 'tak 10/22/2004 21:32'!
loadSoldier
	"self loadSoldier"
	| fName max tframe |
	^ CroquetData
		loadURL: 'http://www.reed.com/TeaLand/ChainReaction/soldier.tea'
		ifAbsentPut: [fName _ #('Content' 'ChainReaction' 'walk-2004-10-11.ASE' ) asPath.
			max _ TLoad3DSMax new initializeWithFileName: fName scale: 0.02.
			tframe _ max frame animation frame.
			tframe boundsDepth: 2.
			tframe initBounds.
			tframe]! !

!CRTeapotMorph class methodsFor: 'instance creation' stamp: 'tak 10/22/2004 11:44'!
simpleNew
	^ self new initMode: #makeSpaceSimple.! !


!Collection methodsFor: 'converting' stamp: 'tak 10/20/2004 18:20'!
asPath
	"#('Contents' 'ChainRaction' 'README.txt') asPath"
	| path |
	path _ OrderedCollection with: FileDirectory default pathName.
	path addAll: self.
	^ FileDirectory pathFrom: path! !


!CroquetData class methodsFor: 'fileIn/Out' stamp: 'tak 10/21/2004 14:35'!
loadURL: aString ifAbsentPut: aBlock 
	| object |
	object _ CroquetData loadURL: aString.
	object
		ifNil: [object _ aBlock value.
			TExporter export: object asBinary: aString].
	^ object! !


!TLoad3DSMaxTest class methodsFor: 'benchmark' stamp: 'tak 10/22/2004 11:14'!
showDrone
	"self showDrone"
	TLoad3DSMaxTest
		showMax: #('Content' 'ChainReaction' 'Drone-2004-10-09.ASE' ) asPath
		offset: 0 @ -1 @ 0
		scale: 1.0
		number: 1! !

!TLoad3DSMaxTest class methodsFor: 'benchmark' stamp: 'tak 10/22/2004 11:09'!
showSoldier
	"self showSoldier"
	TLoad3DSMaxTest
		showMax: #('Content' 'ChainReaction' 'walk-2004-10-11.ASE' ) asPath
		offset: 0 @ -2 @ 0
		scale: 0.02
		number: 1! !


!CRTeapotMorph class reorganize!
('parts bin' descriptionForPartsBin)
('resource' loadAnimationDeath loadAnimationWalk loadDrone loadSoldier)
('instance creation' simpleNew)
!


!CRSpace reorganize!
('events' handlesKeyboard: keyStroke:)
!


!CRAvatar reorganize!
('initialize' initialize initializeForSoldier)
('accessing' driving nextStatus: speedControl:pointerTransform: startDriving: stopDriving)
('driving' death driveStep revive stop walk)
!

